package hurome.diagram.edit.parts;

import hurome.diagram.part.HuromeVisualIDRegistry;

import org.eclipse.draw2d.FigureUtilities;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITextAwareEditPart;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Text;

/**
 * @generated
 */
public class HuromeEditPartFactory implements EditPartFactory {

	/**
	 * @generated
	 */
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof View) {
			View view = (View) model;
			switch (HuromeVisualIDRegistry.getVisualID(view)) {

			case CodeBlockEditPart.VISUAL_ID:
				return new CodeBlockEditPart(view);

			case ConditionalEditPart.VISUAL_ID:
				return new ConditionalEditPart(view);

			case ConditionalCommentEditPart.VISUAL_ID:
				return new ConditionalCommentEditPart(view);

			case InitialPseudoMovementEditPart.VISUAL_ID:
				return new InitialPseudoMovementEditPart(view);

			case DelayEditPart.VISUAL_ID:
				return new DelayEditPart(view);

			case DelayValueEditPart.VISUAL_ID:
				return new DelayValueEditPart(view);

			case FinalPseudoMovementEditPart.VISUAL_ID:
				return new FinalPseudoMovementEditPart(view);

			case VarAssigmentEditPart.VISUAL_ID:
				return new VarAssigmentEditPart(view);

			case VarAssigmentCommentEditPart.VISUAL_ID:
				return new VarAssigmentCommentEditPart(view);

			case SetSpeedEditPart.VISUAL_ID:
				return new SetSpeedEditPart(view);

			case SetSpeedValueEditPart.VISUAL_ID:
				return new SetSpeedValueEditPart(view);

			case SimpleMovementEditPart.VISUAL_ID:
				return new SimpleMovementEditPart(view);

			case SimpleMovementCommentEditPart.VISUAL_ID:
				return new SimpleMovementCommentEditPart(view);

			case VarDeclarationEditPart.VISUAL_ID:
				return new VarDeclarationEditPart(view);

			case VarDeclarationNameEditPart.VISUAL_ID:
				return new VarDeclarationNameEditPart(view);

			case LoopEditPart.VISUAL_ID:
				return new LoopEditPart(view);

			case LoopCommentLoopsEditPart.VISUAL_ID:
				return new LoopCommentLoopsEditPart(view);

			case CodeBlock2EditPart.VISUAL_ID:
				return new CodeBlock2EditPart(view);

			case Delay2EditPart.VISUAL_ID:
				return new Delay2EditPart(view);

			case DelayValue2EditPart.VISUAL_ID:
				return new DelayValue2EditPart(view);

			case InitialPseudoMovement2EditPart.VISUAL_ID:
				return new InitialPseudoMovement2EditPart(view);

			case Conditional2EditPart.VISUAL_ID:
				return new Conditional2EditPart(view);

			case ConditionalComment2EditPart.VISUAL_ID:
				return new ConditionalComment2EditPart(view);

			case CodeBlock3EditPart.VISUAL_ID:
				return new CodeBlock3EditPart(view);

			case FinalPseudoMovement2EditPart.VISUAL_ID:
				return new FinalPseudoMovement2EditPart(view);

			case Loop2EditPart.VISUAL_ID:
				return new Loop2EditPart(view);

			case LoopCommentLoops2EditPart.VISUAL_ID:
				return new LoopCommentLoops2EditPart(view);

			case SetSpeed2EditPart.VISUAL_ID:
				return new SetSpeed2EditPart(view);

			case SetSpeedValue2EditPart.VISUAL_ID:
				return new SetSpeedValue2EditPart(view);

			case SimpleMovement2EditPart.VISUAL_ID:
				return new SimpleMovement2EditPart(view);

			case SimpleMovementComment2EditPart.VISUAL_ID:
				return new SimpleMovementComment2EditPart(view);

			case VarAssigment2EditPart.VISUAL_ID:
				return new VarAssigment2EditPart(view);

			case VarAssigmentComment2EditPart.VISUAL_ID:
				return new VarAssigmentComment2EditPart(view);

			case VarDeclaration2EditPart.VISUAL_ID:
				return new VarDeclaration2EditPart(view);

			case VarDeclarationName2EditPart.VISUAL_ID:
				return new VarDeclarationName2EditPart(view);

			case ConditionalIfCompartmentEditPart.VISUAL_ID:
				return new ConditionalIfCompartmentEditPart(view);

			case ConditionalElseCompartmentEditPart.VISUAL_ID:
				return new ConditionalElseCompartmentEditPart(view);

			case CodeBlockCbCompartmentEditPart.VISUAL_ID:
				return new CodeBlockCbCompartmentEditPart(view);

			case ConditionalIfCompartment2EditPart.VISUAL_ID:
				return new ConditionalIfCompartment2EditPart(view);

			case ConditionalElseCompartment2EditPart.VISUAL_ID:
				return new ConditionalElseCompartment2EditPart(view);

			case CodeBlockCbCompartment2EditPart.VISUAL_ID:
				return new CodeBlockCbCompartment2EditPart(view);

			case LoopLoopFigureCompartmentEditPart.VISUAL_ID:
				return new LoopLoopFigureCompartmentEditPart(view);

			case LoopLoopFigureCompartment2EditPart.VISUAL_ID:
				return new LoopLoopFigureCompartment2EditPart(view);

			case SequenceLinkEditPart.VISUAL_ID:
				return new SequenceLinkEditPart(view);

			}
		}
		return createUnrecognizedEditPart(context, model);
	}

	/**
	 * @generated
	 */
	private EditPart createUnrecognizedEditPart(EditPart context, Object model) {
		// Handle creation of unrecognized child node EditParts here
		return null;
	}

	/**
	 * @generated
	 */
	public static CellEditorLocator getTextCellEditorLocator(
			ITextAwareEditPart source) {
		if (source.getFigure() instanceof WrappingLabel)
			return new TextCellEditorLocator((WrappingLabel) source.getFigure());
		else {
			return new LabelCellEditorLocator((Label) source.getFigure());
		}
	}

	/**
	 * @generated
	 */
	static private class TextCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private WrappingLabel wrapLabel;

		/**
		 * @generated
		 */
		public TextCellEditorLocator(WrappingLabel wrapLabel) {
			this.wrapLabel = wrapLabel;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getWrapLabel() {
			return wrapLabel;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getWrapLabel().getTextBounds().getCopy();
			getWrapLabel().translateToAbsolute(rect);
			if (!text.getFont().isDisposed()) {
				if (getWrapLabel().isTextWrapOn()
						&& getWrapLabel().getText().length() > 0) {
					rect.setSize(new Dimension(text.computeSize(rect.width,
							SWT.DEFAULT)));
				} else {
					int avr = FigureUtilities.getFontMetrics(text.getFont())
							.getAverageCharWidth();
					rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT,
							SWT.DEFAULT)).expand(avr * 2, 0));
				}
			}
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}
	}

	/**
	 * @generated
	 */
	private static class LabelCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private Label label;

		/**
		 * @generated
		 */
		public LabelCellEditorLocator(Label label) {
			this.label = label;
		}

		/**
		 * @generated
		 */
		public Label getLabel() {
			return label;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getLabel().getTextBounds().getCopy();
			getLabel().translateToAbsolute(rect);
			if (!text.getFont().isDisposed()) {
				int avr = FigureUtilities.getFontMetrics(text.getFont())
						.getAverageCharWidth();
				rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT,
						SWT.DEFAULT)).expand(avr * 2, 0));
			}
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}
	}
}
