package hurome.diagram.edit.parts;

import hurome.diagram.edit.policies.LoopItemSemanticEditPolicy;
import hurome.diagram.part.HuromeVisualIDRegistry;
import hurome.diagram.providers.HuromeElementTypes;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.graphics.Color;

/**
 * @generated
 */
public class LoopEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2009;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public LoopEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE,
				new LoopItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {
		org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy lep = new org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(EditPart child) {
				EditPolicy result = child
						.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null) {
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		return primaryShape = new LoopFigure();
	}

	/**
	 * @generated
	 */
	public LoopFigure getPrimaryShape() {
		return (LoopFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof LoopCommentLoopsEditPart) {
			((LoopCommentLoopsEditPart) childEditPart)
					.setLabel(getPrimaryShape().getFigureLoopLoopsFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof LoopCommentLoopsEditPart) {
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {
		return getContentPane();
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(40, 40);
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(5);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(HuromeVisualIDRegistry
				.getType(LoopCommentLoopsEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSource() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(HuromeElementTypes.SequenceLink_4001);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSourceAndTarget(
			IGraphicalEditPart targetEditPart) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (targetEditPart instanceof ConditionalEditPart) {
			types.add(HuromeElementTypes.SequenceLink_4001);
		}
		if (targetEditPart instanceof InitialPseudoMovementEditPart) {
			types.add(HuromeElementTypes.SequenceLink_4001);
		}
		if (targetEditPart instanceof DelayEditPart) {
			types.add(HuromeElementTypes.SequenceLink_4001);
		}
		if (targetEditPart instanceof FinalPseudoMovementEditPart) {
			types.add(HuromeElementTypes.SequenceLink_4001);
		}
		if (targetEditPart instanceof VarAssigmentEditPart) {
			types.add(HuromeElementTypes.SequenceLink_4001);
		}
		if (targetEditPart instanceof SetSpeedEditPart) {
			types.add(HuromeElementTypes.SequenceLink_4001);
		}
		if (targetEditPart instanceof SimpleMovementEditPart) {
			types.add(HuromeElementTypes.SequenceLink_4001);
		}
		if (targetEditPart instanceof VarDeclarationEditPart) {
			types.add(HuromeElementTypes.SequenceLink_4001);
		}
		if (targetEditPart instanceof hurome.diagram.edit.parts.LoopEditPart) {
			types.add(HuromeElementTypes.SequenceLink_4001);
		}
		if (targetEditPart instanceof CodeBlock2EditPart) {
			types.add(HuromeElementTypes.SequenceLink_4001);
		}
		if (targetEditPart instanceof Delay2EditPart) {
			types.add(HuromeElementTypes.SequenceLink_4001);
		}
		if (targetEditPart instanceof InitialPseudoMovement2EditPart) {
			types.add(HuromeElementTypes.SequenceLink_4001);
		}
		if (targetEditPart instanceof Conditional2EditPart) {
			types.add(HuromeElementTypes.SequenceLink_4001);
		}
		if (targetEditPart instanceof CodeBlock3EditPart) {
			types.add(HuromeElementTypes.SequenceLink_4001);
		}
		if (targetEditPart instanceof FinalPseudoMovement2EditPart) {
			types.add(HuromeElementTypes.SequenceLink_4001);
		}
		if (targetEditPart instanceof Loop2EditPart) {
			types.add(HuromeElementTypes.SequenceLink_4001);
		}
		if (targetEditPart instanceof SetSpeed2EditPart) {
			types.add(HuromeElementTypes.SequenceLink_4001);
		}
		if (targetEditPart instanceof SimpleMovement2EditPart) {
			types.add(HuromeElementTypes.SequenceLink_4001);
		}
		if (targetEditPart instanceof VarAssigment2EditPart) {
			types.add(HuromeElementTypes.SequenceLink_4001);
		}
		if (targetEditPart instanceof VarDeclaration2EditPart) {
			types.add(HuromeElementTypes.SequenceLink_4001);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForTarget(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == HuromeElementTypes.SequenceLink_4001) {
			types.add(HuromeElementTypes.Conditional_2001);
			types.add(HuromeElementTypes.InitialPseudoMovement_2003);
			types.add(HuromeElementTypes.Delay_2002);
			types.add(HuromeElementTypes.FinalPseudoMovement_2004);
			types.add(HuromeElementTypes.VarAssigment_2005);
			types.add(HuromeElementTypes.SetSpeed_2006);
			types.add(HuromeElementTypes.SimpleMovement_2007);
			types.add(HuromeElementTypes.VarDeclaration_2008);
			types.add(HuromeElementTypes.Loop_2009);
			types.add(HuromeElementTypes.CodeBlock_3001);
			types.add(HuromeElementTypes.Delay_3002);
			types.add(HuromeElementTypes.InitialPseudoMovement_3003);
			types.add(HuromeElementTypes.Conditional_3006);
			types.add(HuromeElementTypes.CodeBlock_3004);
			types.add(HuromeElementTypes.FinalPseudoMovement_3007);
			types.add(HuromeElementTypes.Loop_3008);
			types.add(HuromeElementTypes.SetSpeed_3009);
			types.add(HuromeElementTypes.SimpleMovement_3010);
			types.add(HuromeElementTypes.VarAssigment_3011);
			types.add(HuromeElementTypes.VarDeclaration_3012);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnTarget() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(HuromeElementTypes.SequenceLink_4001);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForSource(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == HuromeElementTypes.SequenceLink_4001) {
			types.add(HuromeElementTypes.Conditional_2001);
			types.add(HuromeElementTypes.InitialPseudoMovement_2003);
			types.add(HuromeElementTypes.Delay_2002);
			types.add(HuromeElementTypes.FinalPseudoMovement_2004);
			types.add(HuromeElementTypes.VarAssigment_2005);
			types.add(HuromeElementTypes.SetSpeed_2006);
			types.add(HuromeElementTypes.SimpleMovement_2007);
			types.add(HuromeElementTypes.VarDeclaration_2008);
			types.add(HuromeElementTypes.Loop_2009);
			types.add(HuromeElementTypes.CodeBlock_3001);
			types.add(HuromeElementTypes.Delay_3002);
			types.add(HuromeElementTypes.InitialPseudoMovement_3003);
			types.add(HuromeElementTypes.Conditional_3006);
			types.add(HuromeElementTypes.CodeBlock_3004);
			types.add(HuromeElementTypes.FinalPseudoMovement_3007);
			types.add(HuromeElementTypes.Loop_3008);
			types.add(HuromeElementTypes.SetSpeed_3009);
			types.add(HuromeElementTypes.SimpleMovement_3010);
			types.add(HuromeElementTypes.VarAssigment_3011);
			types.add(HuromeElementTypes.VarDeclaration_3012);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public class LoopFigure extends RectangleFigure {

		/**
		 * @generated
		 */
		private Label fFigureLoopLoopsFigure;

		/**
		 * @generated
		 */
		public LoopFigure() {
			this.setLineWidth(3);
			this.setForegroundColor(ColorConstants.blue);
			this.setBackgroundColor(THIS_BACK);
			createContents();
		}

		/**
		 * @generated
		 */
		private void createContents() {

			fFigureLoopLoopsFigure = new Label();
			fFigureLoopLoopsFigure.setText("<...>");

			this.add(fFigureLoopLoopsFigure);

		}

		/**
		 * @generated
		 */
		public Label getFigureLoopLoopsFigure() {
			return fFigureLoopLoopsFigure;
		}

	}

	/**
	 * @generated
	 */
	static final Color THIS_BACK = new Color(null, 173, 234, 234);

}
