package hurome.diagram.edit.policies;

import hurome.diagram.edit.commands.ConditionalCreateCommand;
import hurome.diagram.edit.commands.DelayCreateCommand;
import hurome.diagram.edit.commands.FinalPseudoMovementCreateCommand;
import hurome.diagram.edit.commands.InitialPseudoMovementCreateCommand;
import hurome.diagram.edit.commands.LoopCreateCommand;
import hurome.diagram.edit.commands.SetSpeedCreateCommand;
import hurome.diagram.edit.commands.SimpleMovementCreateCommand;
import hurome.diagram.edit.commands.VarAssigmentCreateCommand;
import hurome.diagram.edit.commands.VarDeclarationCreateCommand;
import hurome.diagram.providers.HuromeElementTypes;

import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.commands.core.commands.DuplicateEObjectsCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DuplicateElementsRequest;

/**
 * @generated
 */
public class CodeBlockItemSemanticEditPolicy extends
		HuromeBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	public CodeBlockItemSemanticEditPolicy() {
		super(HuromeElementTypes.CodeBlock_1000);
	}

	/**
	 * @generated
	 */
	protected Command getCreateCommand(CreateElementRequest req) {
		if (HuromeElementTypes.Conditional_2001 == req.getElementType()) {
			return getGEFWrapper(new ConditionalCreateCommand(req));
		}
		if (HuromeElementTypes.InitialPseudoMovement_2003 == req
				.getElementType()) {
			return getGEFWrapper(new InitialPseudoMovementCreateCommand(req));
		}
		if (HuromeElementTypes.Delay_2002 == req.getElementType()) {
			return getGEFWrapper(new DelayCreateCommand(req));
		}
		if (HuromeElementTypes.FinalPseudoMovement_2004 == req.getElementType()) {
			return getGEFWrapper(new FinalPseudoMovementCreateCommand(req));
		}
		if (HuromeElementTypes.VarAssigment_2005 == req.getElementType()) {
			return getGEFWrapper(new VarAssigmentCreateCommand(req));
		}
		if (HuromeElementTypes.SetSpeed_2006 == req.getElementType()) {
			return getGEFWrapper(new SetSpeedCreateCommand(req));
		}
		if (HuromeElementTypes.SimpleMovement_2007 == req.getElementType()) {
			return getGEFWrapper(new SimpleMovementCreateCommand(req));
		}
		if (HuromeElementTypes.VarDeclaration_2008 == req.getElementType()) {
			return getGEFWrapper(new VarDeclarationCreateCommand(req));
		}
		if (HuromeElementTypes.Loop_2009 == req.getElementType()) {
			return getGEFWrapper(new LoopCreateCommand(req));
		}
		return super.getCreateCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getDuplicateCommand(DuplicateElementsRequest req) {
		TransactionalEditingDomain editingDomain = ((IGraphicalEditPart) getHost())
				.getEditingDomain();
		return getGEFWrapper(new DuplicateAnythingCommand(editingDomain, req));
	}

	/**
	 * @generated
	 */
	private static class DuplicateAnythingCommand extends
			DuplicateEObjectsCommand {

		/**
		 * @generated
		 */
		public DuplicateAnythingCommand(
				TransactionalEditingDomain editingDomain,
				DuplicateElementsRequest req) {
			super(editingDomain, req.getLabel(), req
					.getElementsToBeDuplicated(), req
					.getAllDuplicatedElementsMap());
		}

	}

}
