package hurome.diagram.navigator;

import hurome.diagram.edit.parts.CodeBlock2EditPart;
import hurome.diagram.edit.parts.CodeBlock3EditPart;
import hurome.diagram.edit.parts.CodeBlockCbCompartment2EditPart;
import hurome.diagram.edit.parts.CodeBlockCbCompartmentEditPart;
import hurome.diagram.edit.parts.CodeBlockEditPart;
import hurome.diagram.edit.parts.Conditional2EditPart;
import hurome.diagram.edit.parts.ConditionalEditPart;
import hurome.diagram.edit.parts.ConditionalElseCompartment2EditPart;
import hurome.diagram.edit.parts.ConditionalElseCompartmentEditPart;
import hurome.diagram.edit.parts.ConditionalIfCompartment2EditPart;
import hurome.diagram.edit.parts.ConditionalIfCompartmentEditPart;
import hurome.diagram.edit.parts.Delay2EditPart;
import hurome.diagram.edit.parts.DelayEditPart;
import hurome.diagram.edit.parts.FinalPseudoMovement2EditPart;
import hurome.diagram.edit.parts.FinalPseudoMovementEditPart;
import hurome.diagram.edit.parts.InitialPseudoMovement2EditPart;
import hurome.diagram.edit.parts.InitialPseudoMovementEditPart;
import hurome.diagram.edit.parts.Loop2EditPart;
import hurome.diagram.edit.parts.LoopEditPart;
import hurome.diagram.edit.parts.LoopLoopFigureCompartment2EditPart;
import hurome.diagram.edit.parts.LoopLoopFigureCompartmentEditPart;
import hurome.diagram.edit.parts.SequenceLinkEditPart;
import hurome.diagram.edit.parts.SetSpeed2EditPart;
import hurome.diagram.edit.parts.SetSpeedEditPart;
import hurome.diagram.edit.parts.SimpleMovement2EditPart;
import hurome.diagram.edit.parts.SimpleMovementEditPart;
import hurome.diagram.edit.parts.VarAssigment2EditPart;
import hurome.diagram.edit.parts.VarAssigmentEditPart;
import hurome.diagram.edit.parts.VarDeclaration2EditPart;
import hurome.diagram.edit.parts.VarDeclarationEditPart;
import hurome.diagram.part.HuromeVisualIDRegistry;
import hurome.diagram.part.Messages;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedList;

import org.eclipse.core.resources.IFile;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.edit.domain.AdapterFactoryEditingDomain;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.workspace.util.WorkspaceSynchronizer;
import org.eclipse.gmf.runtime.emf.core.GMFEditingDomainFactory;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonContentProvider;

/**
 * @generated
 */
public class HuromeNavigatorContentProvider implements ICommonContentProvider {

	/**
	 * @generated
	 */
	private static final Object[] EMPTY_ARRAY = new Object[0];

	/**
	 * @generated
	 */
	private Viewer myViewer;

	/**
	 * @generated
	 */
	private AdapterFactoryEditingDomain myEditingDomain;

	/**
	 * @generated
	 */
	private WorkspaceSynchronizer myWorkspaceSynchronizer;

	/**
	 * @generated
	 */
	private Runnable myViewerRefreshRunnable;

	/**
	 * @generated
	 */
	@SuppressWarnings({ "unchecked", "serial", "rawtypes" })
	public HuromeNavigatorContentProvider() {
		TransactionalEditingDomain editingDomain = GMFEditingDomainFactory.INSTANCE
				.createEditingDomain();
		myEditingDomain = (AdapterFactoryEditingDomain) editingDomain;
		myEditingDomain.setResourceToReadOnlyMap(new HashMap() {
			public Object get(Object key) {
				if (!containsKey(key)) {
					put(key, Boolean.TRUE);
				}
				return super.get(key);
			}
		});
		myViewerRefreshRunnable = new Runnable() {
			public void run() {
				if (myViewer != null) {
					myViewer.refresh();
				}
			}
		};
		myWorkspaceSynchronizer = new WorkspaceSynchronizer(editingDomain,
				new WorkspaceSynchronizer.Delegate() {
					public void dispose() {
					}

					public boolean handleResourceChanged(final Resource resource) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}

					public boolean handleResourceDeleted(Resource resource) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}

					public boolean handleResourceMoved(Resource resource,
							final URI newURI) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}
				});
	}

	/**
	 * @generated
	 */
	public void dispose() {
		myWorkspaceSynchronizer.dispose();
		myWorkspaceSynchronizer = null;
		myViewerRefreshRunnable = null;
		myViewer = null;
		unloadAllResources();
		((TransactionalEditingDomain) myEditingDomain).dispose();
		myEditingDomain = null;
	}

	/**
	 * @generated
	 */
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		myViewer = viewer;
	}

	/**
	 * @generated
	 */
	void unloadAllResources() {
		for (Resource nextResource : myEditingDomain.getResourceSet()
				.getResources()) {
			nextResource.unload();
		}
	}

	/**
	 * @generated
	 */
	void asyncRefresh() {
		if (myViewer != null && !myViewer.getControl().isDisposed()) {
			myViewer.getControl().getDisplay()
					.asyncExec(myViewerRefreshRunnable);
		}
	}

	/**
	 * @generated
	 */
	public Object[] getElements(Object inputElement) {
		return getChildren(inputElement);
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public Object[] getChildren(Object parentElement) {
		if (parentElement instanceof IFile) {
			IFile file = (IFile) parentElement;
			URI fileURI = URI.createPlatformResourceURI(file.getFullPath()
					.toString(), true);
			Resource resource = myEditingDomain.getResourceSet().getResource(
					fileURI, true);
			ArrayList<HuromeNavigatorItem> result = new ArrayList<HuromeNavigatorItem>();
			ArrayList<View> topViews = new ArrayList<View>(resource
					.getContents().size());
			for (EObject o : resource.getContents()) {
				if (o instanceof View) {
					topViews.add((View) o);
				}
			}
			result.addAll(createNavigatorItems(
					selectViewsByType(topViews, CodeBlockEditPart.MODEL_ID),
					file, false));
			return result.toArray();
		}

		if (parentElement instanceof HuromeNavigatorGroup) {
			HuromeNavigatorGroup group = (HuromeNavigatorGroup) parentElement;
			return group.getChildren();
		}

		if (parentElement instanceof HuromeNavigatorItem) {
			HuromeNavigatorItem navigatorItem = (HuromeNavigatorItem) parentElement;
			if (navigatorItem.isLeaf() || !isOwnView(navigatorItem.getView())) {
				return EMPTY_ARRAY;
			}
			return getViewChildren(navigatorItem.getView(), parentElement);
		}

		return EMPTY_ARRAY;
	}

	/**
	 * @generated
	 */
	private Object[] getViewChildren(View view, Object parentElement) {
		switch (HuromeVisualIDRegistry.getVisualID(view)) {

		case InitialPseudoMovement2EditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Node sv = (Node) view;
			HuromeNavigatorGroup incominglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_InitialPseudoMovement_3003_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup outgoinglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_InitialPseudoMovement_3003_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case VarDeclaration2EditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Node sv = (Node) view;
			HuromeNavigatorGroup incominglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_VarDeclaration_3012_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup outgoinglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_VarDeclaration_3012_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case SetSpeedEditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Node sv = (Node) view;
			HuromeNavigatorGroup incominglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_SetSpeed_2006_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup outgoinglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_SetSpeed_2006_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case LoopEditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Node sv = (Node) view;
			HuromeNavigatorGroup incominglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_Loop_2009_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup outgoinglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_Loop_2009_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(LoopLoopFigureCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry.getType(Delay2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(LoopLoopFigureCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(InitialPseudoMovement2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(LoopLoopFigureCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(Conditional2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(LoopLoopFigureCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(FinalPseudoMovement2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(LoopLoopFigureCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry.getType(Loop2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(LoopLoopFigureCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry.getType(SetSpeed2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(LoopLoopFigureCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(SimpleMovement2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(LoopLoopFigureCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(VarAssigment2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(LoopLoopFigureCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(VarDeclaration2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case ConditionalEditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Node sv = (Node) view;
			HuromeNavigatorGroup incominglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_Conditional_2001_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup outgoinglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_Conditional_2001_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(ConditionalIfCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(CodeBlock2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(ConditionalElseCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(CodeBlock3EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case CodeBlockEditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Diagram sv = (Diagram) view;
			HuromeNavigatorGroup links = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_CodeBlock_1000_links,
					"icons/linksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(ConditionalEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(InitialPseudoMovementEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry.getType(DelayEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(FinalPseudoMovementEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(VarAssigmentEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry.getType(SetSpeedEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SimpleMovementEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(VarDeclarationEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry.getType(LoopEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getDiagramLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			if (!links.isEmpty()) {
				result.add(links);
			}
			return result.toArray();
		}

		case SetSpeed2EditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Node sv = (Node) view;
			HuromeNavigatorGroup incominglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_SetSpeed_3009_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup outgoinglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_SetSpeed_3009_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case Loop2EditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Node sv = (Node) view;
			HuromeNavigatorGroup incominglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_Loop_3008_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup outgoinglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_Loop_3008_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(LoopLoopFigureCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry.getType(Delay2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(LoopLoopFigureCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(InitialPseudoMovement2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(LoopLoopFigureCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(Conditional2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(LoopLoopFigureCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(FinalPseudoMovement2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(LoopLoopFigureCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry.getType(Loop2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(LoopLoopFigureCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry.getType(SetSpeed2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(LoopLoopFigureCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(SimpleMovement2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(LoopLoopFigureCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(VarAssigment2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(LoopLoopFigureCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(VarDeclaration2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case FinalPseudoMovement2EditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Node sv = (Node) view;
			HuromeNavigatorGroup incominglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_FinalPseudoMovement_3007_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup outgoinglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_FinalPseudoMovement_3007_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case FinalPseudoMovementEditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Node sv = (Node) view;
			HuromeNavigatorGroup incominglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_FinalPseudoMovement_2004_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup outgoinglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_FinalPseudoMovement_2004_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case Delay2EditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Node sv = (Node) view;
			HuromeNavigatorGroup incominglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_Delay_3002_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup outgoinglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_Delay_3002_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case CodeBlock3EditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Node sv = (Node) view;
			HuromeNavigatorGroup incominglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_CodeBlock_3004_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup outgoinglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_CodeBlock_3004_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlockCbCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry.getType(Delay2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlockCbCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(InitialPseudoMovement2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlockCbCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(Conditional2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlockCbCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(FinalPseudoMovement2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlockCbCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry.getType(Loop2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlockCbCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry.getType(SetSpeed2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlockCbCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(SimpleMovement2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlockCbCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(VarAssigment2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlockCbCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(VarDeclaration2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case InitialPseudoMovementEditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Node sv = (Node) view;
			HuromeNavigatorGroup incominglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_InitialPseudoMovement_2003_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup outgoinglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_InitialPseudoMovement_2003_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case CodeBlock2EditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Node sv = (Node) view;
			HuromeNavigatorGroup incominglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_CodeBlock_3001_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup outgoinglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_CodeBlock_3001_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlockCbCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry.getType(Delay2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlockCbCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(InitialPseudoMovement2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlockCbCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(Conditional2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlockCbCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(FinalPseudoMovement2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlockCbCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry.getType(Loop2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlockCbCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry.getType(SetSpeed2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlockCbCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(SimpleMovement2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlockCbCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(VarAssigment2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlockCbCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(VarDeclaration2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case VarAssigmentEditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Node sv = (Node) view;
			HuromeNavigatorGroup incominglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_VarAssigment_2005_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup outgoinglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_VarAssigment_2005_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case SequenceLinkEditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			HuromeNavigatorGroup target = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_SequenceLink_4001_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup source = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_SequenceLink_4001_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(ConditionalEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(InitialPseudoMovementEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					HuromeVisualIDRegistry.getType(DelayEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(FinalPseudoMovementEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(VarAssigmentEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					HuromeVisualIDRegistry.getType(SetSpeedEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SimpleMovementEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(VarDeclarationEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					HuromeVisualIDRegistry.getType(LoopEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlock2EditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					HuromeVisualIDRegistry.getType(Delay2EditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(InitialPseudoMovement2EditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(Conditional2EditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlock3EditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(FinalPseudoMovement2EditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					HuromeVisualIDRegistry.getType(Loop2EditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					HuromeVisualIDRegistry.getType(SetSpeed2EditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SimpleMovement2EditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(VarAssigment2EditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(VarDeclaration2EditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(ConditionalEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(InitialPseudoMovementEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					HuromeVisualIDRegistry.getType(DelayEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(FinalPseudoMovementEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(VarAssigmentEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					HuromeVisualIDRegistry.getType(SetSpeedEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SimpleMovementEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(VarDeclarationEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					HuromeVisualIDRegistry.getType(LoopEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlock2EditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					HuromeVisualIDRegistry.getType(Delay2EditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(InitialPseudoMovement2EditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(Conditional2EditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(CodeBlock3EditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(FinalPseudoMovement2EditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					HuromeVisualIDRegistry.getType(Loop2EditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					HuromeVisualIDRegistry.getType(SetSpeed2EditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SimpleMovement2EditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(VarAssigment2EditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(VarDeclaration2EditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case SimpleMovement2EditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Node sv = (Node) view;
			HuromeNavigatorGroup incominglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_SimpleMovement_3010_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup outgoinglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_SimpleMovement_3010_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case VarDeclarationEditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Node sv = (Node) view;
			HuromeNavigatorGroup incominglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_VarDeclaration_2008_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup outgoinglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_VarDeclaration_2008_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case VarAssigment2EditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Node sv = (Node) view;
			HuromeNavigatorGroup incominglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_VarAssigment_3011_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup outgoinglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_VarAssigment_3011_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case SimpleMovementEditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Node sv = (Node) view;
			HuromeNavigatorGroup incominglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_SimpleMovement_2007_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup outgoinglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_SimpleMovement_2007_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case DelayEditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Node sv = (Node) view;
			HuromeNavigatorGroup incominglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_Delay_2002_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup outgoinglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_Delay_2002_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case Conditional2EditPart.VISUAL_ID: {
			LinkedList<HuromeAbstractNavigatorItem> result = new LinkedList<HuromeAbstractNavigatorItem>();
			Node sv = (Node) view;
			HuromeNavigatorGroup incominglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_Conditional_3006_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			HuromeNavigatorGroup outgoinglinks = new HuromeNavigatorGroup(
					Messages.NavigatorGroupName_Conditional_3006_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(ConditionalIfCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(CodeBlock2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(ConditionalElseCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					HuromeVisualIDRegistry
							.getType(CodeBlock3EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					HuromeVisualIDRegistry
							.getType(SequenceLinkEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}
		}
		return EMPTY_ARRAY;
	}

	/**
	 * @generated
	 */
	private Collection<View> getLinksSourceByType(Collection<Edge> edges,
			String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (Edge nextEdge : edges) {
			View nextEdgeSource = nextEdge.getSource();
			if (type.equals(nextEdgeSource.getType())
					&& isOwnView(nextEdgeSource)) {
				result.add(nextEdgeSource);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getLinksTargetByType(Collection<Edge> edges,
			String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (Edge nextEdge : edges) {
			View nextEdgeTarget = nextEdge.getTarget();
			if (type.equals(nextEdgeTarget.getType())
					&& isOwnView(nextEdgeTarget)) {
				result.add(nextEdgeTarget);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getOutgoingLinksByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getSourceEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getIncomingLinksByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getTargetEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getChildrenByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getChildren(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getDiagramLinksByType(
			Collection<Diagram> diagrams, String type) {
		ArrayList<View> result = new ArrayList<View>();
		for (Diagram nextDiagram : diagrams) {
			result.addAll(selectViewsByType(nextDiagram.getEdges(), type));
		}
		return result;
	}

	// TODO refactor as static method
	/**
	 * @generated
	 */
	private Collection<View> selectViewsByType(Collection<View> views,
			String type) {
		ArrayList<View> result = new ArrayList<View>();
		for (View nextView : views) {
			if (type.equals(nextView.getType()) && isOwnView(nextView)) {
				result.add(nextView);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return CodeBlockEditPart.MODEL_ID.equals(HuromeVisualIDRegistry
				.getModelID(view));
	}

	/**
	 * @generated
	 */
	private Collection<HuromeNavigatorItem> createNavigatorItems(
			Collection<View> views, Object parent, boolean isLeafs) {
		ArrayList<HuromeNavigatorItem> result = new ArrayList<HuromeNavigatorItem>(
				views.size());
		for (View nextView : views) {
			result.add(new HuromeNavigatorItem(nextView, parent, isLeafs));
		}
		return result;
	}

	/**
	 * @generated
	 */
	public Object getParent(Object element) {
		if (element instanceof HuromeAbstractNavigatorItem) {
			HuromeAbstractNavigatorItem abstractNavigatorItem = (HuromeAbstractNavigatorItem) element;
			return abstractNavigatorItem.getParent();
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean hasChildren(Object element) {
		return element instanceof IFile || getChildren(element).length > 0;
	}

}
