package hurome.diagram.navigator;

import hurome.CodeBlock;
import hurome.FinalPseudoMovement;
import hurome.InitialPseudoMovement;
import hurome.SequenceLink;
import hurome.diagram.edit.parts.CodeBlock2EditPart;
import hurome.diagram.edit.parts.CodeBlock3EditPart;
import hurome.diagram.edit.parts.CodeBlockEditPart;
import hurome.diagram.edit.parts.Conditional2EditPart;
import hurome.diagram.edit.parts.ConditionalComment2EditPart;
import hurome.diagram.edit.parts.ConditionalCommentEditPart;
import hurome.diagram.edit.parts.ConditionalEditPart;
import hurome.diagram.edit.parts.Delay2EditPart;
import hurome.diagram.edit.parts.DelayEditPart;
import hurome.diagram.edit.parts.DelayValue2EditPart;
import hurome.diagram.edit.parts.DelayValueEditPart;
import hurome.diagram.edit.parts.FinalPseudoMovement2EditPart;
import hurome.diagram.edit.parts.FinalPseudoMovementEditPart;
import hurome.diagram.edit.parts.InitialPseudoMovement2EditPart;
import hurome.diagram.edit.parts.InitialPseudoMovementEditPart;
import hurome.diagram.edit.parts.Loop2EditPart;
import hurome.diagram.edit.parts.LoopCommentLoops2EditPart;
import hurome.diagram.edit.parts.LoopCommentLoopsEditPart;
import hurome.diagram.edit.parts.LoopEditPart;
import hurome.diagram.edit.parts.SequenceLinkEditPart;
import hurome.diagram.edit.parts.SetSpeed2EditPart;
import hurome.diagram.edit.parts.SetSpeedEditPart;
import hurome.diagram.edit.parts.SetSpeedValue2EditPart;
import hurome.diagram.edit.parts.SetSpeedValueEditPart;
import hurome.diagram.edit.parts.SimpleMovement2EditPart;
import hurome.diagram.edit.parts.SimpleMovementComment2EditPart;
import hurome.diagram.edit.parts.SimpleMovementCommentEditPart;
import hurome.diagram.edit.parts.SimpleMovementEditPart;
import hurome.diagram.edit.parts.VarAssigment2EditPart;
import hurome.diagram.edit.parts.VarAssigmentComment2EditPart;
import hurome.diagram.edit.parts.VarAssigmentCommentEditPart;
import hurome.diagram.edit.parts.VarAssigmentEditPart;
import hurome.diagram.edit.parts.VarDeclaration2EditPart;
import hurome.diagram.edit.parts.VarDeclarationEditPart;
import hurome.diagram.edit.parts.VarDeclarationName2EditPart;
import hurome.diagram.edit.parts.VarDeclarationNameEditPart;
import hurome.diagram.part.HuromeDiagramEditorPlugin;
import hurome.diagram.part.HuromeVisualIDRegistry;
import hurome.diagram.providers.HuromeElementTypes;
import hurome.diagram.providers.HuromeParserProvider;

import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

/**
 * @generated
 */
public class HuromeNavigatorLabelProvider extends LabelProvider implements
		ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		HuromeDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		HuromeDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof HuromeNavigatorItem
				&& !isOwnView(((HuromeNavigatorItem) element).getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof HuromeNavigatorGroup) {
			HuromeNavigatorGroup group = (HuromeNavigatorGroup) element;
			return HuromeDiagramEditorPlugin.getInstance().getBundledImage(
					group.getIcon());
		}

		if (element instanceof HuromeNavigatorItem) {
			HuromeNavigatorItem navigatorItem = (HuromeNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (HuromeVisualIDRegistry.getVisualID(view)) {
		case InitialPseudoMovement2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http//:hurome?InitialPseudoMovement", HuromeElementTypes.InitialPseudoMovement_3003); //$NON-NLS-1$
		case VarDeclaration2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http//:hurome?VarDeclaration", HuromeElementTypes.VarDeclaration_3012); //$NON-NLS-1$
		case SetSpeedEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http//:hurome?SetSpeed", HuromeElementTypes.SetSpeed_2006); //$NON-NLS-1$
		case LoopEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http//:hurome?Loop", HuromeElementTypes.Loop_2009); //$NON-NLS-1$
		case ConditionalEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http//:hurome?Conditional", HuromeElementTypes.Conditional_2001); //$NON-NLS-1$
		case CodeBlockEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?http//:hurome?CodeBlock", HuromeElementTypes.CodeBlock_1000); //$NON-NLS-1$
		case SetSpeed2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http//:hurome?SetSpeed", HuromeElementTypes.SetSpeed_3009); //$NON-NLS-1$
		case Loop2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http//:hurome?Loop", HuromeElementTypes.Loop_3008); //$NON-NLS-1$
		case FinalPseudoMovement2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http//:hurome?FinalPseudoMovement", HuromeElementTypes.FinalPseudoMovement_3007); //$NON-NLS-1$
		case FinalPseudoMovementEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http//:hurome?FinalPseudoMovement", HuromeElementTypes.FinalPseudoMovement_2004); //$NON-NLS-1$
		case Delay2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http//:hurome?Delay", HuromeElementTypes.Delay_3002); //$NON-NLS-1$
		case CodeBlock3EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http//:hurome?CodeBlock", HuromeElementTypes.CodeBlock_3004); //$NON-NLS-1$
		case InitialPseudoMovementEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http//:hurome?InitialPseudoMovement", HuromeElementTypes.InitialPseudoMovement_2003); //$NON-NLS-1$
		case CodeBlock2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http//:hurome?CodeBlock", HuromeElementTypes.CodeBlock_3001); //$NON-NLS-1$
		case VarAssigmentEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http//:hurome?VarAssigment", HuromeElementTypes.VarAssigment_2005); //$NON-NLS-1$
		case SequenceLinkEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http//:hurome?SequenceLink", HuromeElementTypes.SequenceLink_4001); //$NON-NLS-1$
		case SimpleMovement2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http//:hurome?SimpleMovement", HuromeElementTypes.SimpleMovement_3010); //$NON-NLS-1$
		case VarDeclarationEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http//:hurome?VarDeclaration", HuromeElementTypes.VarDeclaration_2008); //$NON-NLS-1$
		case VarAssigment2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http//:hurome?VarAssigment", HuromeElementTypes.VarAssigment_3011); //$NON-NLS-1$
		case SimpleMovementEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http//:hurome?SimpleMovement", HuromeElementTypes.SimpleMovement_2007); //$NON-NLS-1$
		case DelayEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http//:hurome?Delay", HuromeElementTypes.Delay_2002); //$NON-NLS-1$
		case Conditional2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http//:hurome?Conditional", HuromeElementTypes.Conditional_3006); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = HuromeDiagramEditorPlugin.getInstance()
				.getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null && elementType != null
				&& HuromeElementTypes.isKnownElementType(elementType)) {
			image = HuromeElementTypes.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof HuromeNavigatorGroup) {
			HuromeNavigatorGroup group = (HuromeNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof HuromeNavigatorItem) {
			HuromeNavigatorItem navigatorItem = (HuromeNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (HuromeVisualIDRegistry.getVisualID(view)) {
		case InitialPseudoMovement2EditPart.VISUAL_ID:
			return getInitialPseudoMovement_3003Text(view);
		case VarDeclaration2EditPart.VISUAL_ID:
			return getVarDeclaration_3012Text(view);
		case SetSpeedEditPart.VISUAL_ID:
			return getSetSpeed_2006Text(view);
		case LoopEditPart.VISUAL_ID:
			return getLoop_2009Text(view);
		case ConditionalEditPart.VISUAL_ID:
			return getConditional_2001Text(view);
		case CodeBlockEditPart.VISUAL_ID:
			return getCodeBlock_1000Text(view);
		case SetSpeed2EditPart.VISUAL_ID:
			return getSetSpeed_3009Text(view);
		case Loop2EditPart.VISUAL_ID:
			return getLoop_3008Text(view);
		case FinalPseudoMovement2EditPart.VISUAL_ID:
			return getFinalPseudoMovement_3007Text(view);
		case FinalPseudoMovementEditPart.VISUAL_ID:
			return getFinalPseudoMovement_2004Text(view);
		case Delay2EditPart.VISUAL_ID:
			return getDelay_3002Text(view);
		case CodeBlock3EditPart.VISUAL_ID:
			return getCodeBlock_3004Text(view);
		case InitialPseudoMovementEditPart.VISUAL_ID:
			return getInitialPseudoMovement_2003Text(view);
		case CodeBlock2EditPart.VISUAL_ID:
			return getCodeBlock_3001Text(view);
		case VarAssigmentEditPart.VISUAL_ID:
			return getVarAssigment_2005Text(view);
		case SequenceLinkEditPart.VISUAL_ID:
			return getSequenceLink_4001Text(view);
		case SimpleMovement2EditPart.VISUAL_ID:
			return getSimpleMovement_3010Text(view);
		case VarDeclarationEditPart.VISUAL_ID:
			return getVarDeclaration_2008Text(view);
		case VarAssigment2EditPart.VISUAL_ID:
			return getVarAssigment_3011Text(view);
		case SimpleMovementEditPart.VISUAL_ID:
			return getSimpleMovement_2007Text(view);
		case DelayEditPart.VISUAL_ID:
			return getDelay_2002Text(view);
		case Conditional2EditPart.VISUAL_ID:
			return getConditional_3006Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getInitialPseudoMovement_3003Text(View view) {
		InitialPseudoMovement domainModelElement = (InitialPseudoMovement) view
				.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getComment();
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 3003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getVarDeclaration_3012Text(View view) {
		IParser parser = HuromeParserProvider.getParser(
				HuromeElementTypes.VarDeclaration_3012,
				view.getElement() != null ? view.getElement() : view,
				HuromeVisualIDRegistry
						.getType(VarDeclarationName2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5009); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSetSpeed_2006Text(View view) {
		IParser parser = HuromeParserProvider
				.getParser(HuromeElementTypes.SetSpeed_2006,
						view.getElement() != null ? view.getElement() : view,
						HuromeVisualIDRegistry
								.getType(SetSpeedValueEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getLoop_2009Text(View view) {
		IParser parser = HuromeParserProvider.getParser(
				HuromeElementTypes.Loop_2009,
				view.getElement() != null ? view.getElement() : view,
				HuromeVisualIDRegistry
						.getType(LoopCommentLoopsEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5005); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getConditional_2001Text(View view) {
		IParser parser = HuromeParserProvider.getParser(
				HuromeElementTypes.Conditional_2001,
				view.getElement() != null ? view.getElement() : view,
				HuromeVisualIDRegistry
						.getType(ConditionalCommentEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5013); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getCodeBlock_1000Text(View view) {
		CodeBlock domainModelElement = (CodeBlock) view.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getComment();
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 1000); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSetSpeed_3009Text(View view) {
		IParser parser = HuromeParserProvider.getParser(
				HuromeElementTypes.SetSpeed_3009,
				view.getElement() != null ? view.getElement() : view,
				HuromeVisualIDRegistry
						.getType(SetSpeedValue2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5006); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getLoop_3008Text(View view) {
		IParser parser = HuromeParserProvider.getParser(
				HuromeElementTypes.Loop_3008,
				view.getElement() != null ? view.getElement() : view,
				HuromeVisualIDRegistry
						.getType(LoopCommentLoops2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5010); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getFinalPseudoMovement_3007Text(View view) {
		FinalPseudoMovement domainModelElement = (FinalPseudoMovement) view
				.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getComment();
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 3007); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getFinalPseudoMovement_2004Text(View view) {
		FinalPseudoMovement domainModelElement = (FinalPseudoMovement) view
				.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getComment();
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 2004); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getDelay_3002Text(View view) {
		IParser parser = HuromeParserProvider.getParser(
				HuromeElementTypes.Delay_3002,
				view.getElement() != null ? view.getElement() : view,
				HuromeVisualIDRegistry.getType(DelayValue2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5011); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getCodeBlock_3004Text(View view) {
		CodeBlock domainModelElement = (CodeBlock) view.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getComment();
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 3004); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getInitialPseudoMovement_2003Text(View view) {
		InitialPseudoMovement domainModelElement = (InitialPseudoMovement) view
				.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getComment();
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 2003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getCodeBlock_3001Text(View view) {
		CodeBlock domainModelElement = (CodeBlock) view.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getComment();
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 3001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getVarAssigment_2005Text(View view) {
		IParser parser = HuromeParserProvider.getParser(
				HuromeElementTypes.VarAssigment_2005,
				view.getElement() != null ? view.getElement() : view,
				HuromeVisualIDRegistry
						.getType(VarAssigmentCommentEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSequenceLink_4001Text(View view) {
		SequenceLink domainModelElement = (SequenceLink) view.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getComment();
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 4001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSimpleMovement_3010Text(View view) {
		IParser parser = HuromeParserProvider.getParser(
				HuromeElementTypes.SimpleMovement_3010,
				view.getElement() != null ? view.getElement() : view,
				HuromeVisualIDRegistry
						.getType(SimpleMovementComment2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5007); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getVarDeclaration_2008Text(View view) {
		IParser parser = HuromeParserProvider.getParser(
				HuromeElementTypes.VarDeclaration_2008,
				view.getElement() != null ? view.getElement() : view,
				HuromeVisualIDRegistry
						.getType(VarDeclarationNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5004); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getVarAssigment_3011Text(View view) {
		IParser parser = HuromeParserProvider.getParser(
				HuromeElementTypes.VarAssigment_3011,
				view.getElement() != null ? view.getElement() : view,
				HuromeVisualIDRegistry
						.getType(VarAssigmentComment2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5008); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSimpleMovement_2007Text(View view) {
		IParser parser = HuromeParserProvider.getParser(
				HuromeElementTypes.SimpleMovement_2007,
				view.getElement() != null ? view.getElement() : view,
				HuromeVisualIDRegistry
						.getType(SimpleMovementCommentEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getDelay_2002Text(View view) {
		IParser parser = HuromeParserProvider.getParser(
				HuromeElementTypes.Delay_2002,
				view.getElement() != null ? view.getElement() : view,
				HuromeVisualIDRegistry.getType(DelayValueEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5014); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getConditional_3006Text(View view) {
		IParser parser = HuromeParserProvider.getParser(
				HuromeElementTypes.Conditional_3006,
				view.getElement() != null ? view.getElement() : view,
				HuromeVisualIDRegistry
						.getType(ConditionalComment2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			HuromeDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5012); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return CodeBlockEditPart.MODEL_ID.equals(HuromeVisualIDRegistry
				.getModelID(view));
	}

}
