package hurome.diagram.part;

import hurome.CodeBlock;
import hurome.HuromePackage;
import hurome.diagram.edit.parts.CodeBlock2EditPart;
import hurome.diagram.edit.parts.CodeBlock3EditPart;
import hurome.diagram.edit.parts.CodeBlockCbCompartment2EditPart;
import hurome.diagram.edit.parts.CodeBlockCbCompartmentEditPart;
import hurome.diagram.edit.parts.CodeBlockEditPart;
import hurome.diagram.edit.parts.Conditional2EditPart;
import hurome.diagram.edit.parts.ConditionalComment2EditPart;
import hurome.diagram.edit.parts.ConditionalCommentEditPart;
import hurome.diagram.edit.parts.ConditionalEditPart;
import hurome.diagram.edit.parts.ConditionalElseCompartment2EditPart;
import hurome.diagram.edit.parts.ConditionalElseCompartmentEditPart;
import hurome.diagram.edit.parts.ConditionalIfCompartment2EditPart;
import hurome.diagram.edit.parts.ConditionalIfCompartmentEditPart;
import hurome.diagram.edit.parts.Delay2EditPart;
import hurome.diagram.edit.parts.DelayEditPart;
import hurome.diagram.edit.parts.DelayValue2EditPart;
import hurome.diagram.edit.parts.DelayValueEditPart;
import hurome.diagram.edit.parts.FinalPseudoMovement2EditPart;
import hurome.diagram.edit.parts.FinalPseudoMovementEditPart;
import hurome.diagram.edit.parts.InitialPseudoMovement2EditPart;
import hurome.diagram.edit.parts.InitialPseudoMovementEditPart;
import hurome.diagram.edit.parts.Loop2EditPart;
import hurome.diagram.edit.parts.LoopCommentLoops2EditPart;
import hurome.diagram.edit.parts.LoopCommentLoopsEditPart;
import hurome.diagram.edit.parts.LoopEditPart;
import hurome.diagram.edit.parts.LoopLoopFigureCompartment2EditPart;
import hurome.diagram.edit.parts.LoopLoopFigureCompartmentEditPart;
import hurome.diagram.edit.parts.SequenceLinkEditPart;
import hurome.diagram.edit.parts.SetSpeed2EditPart;
import hurome.diagram.edit.parts.SetSpeedEditPart;
import hurome.diagram.edit.parts.SetSpeedValue2EditPart;
import hurome.diagram.edit.parts.SetSpeedValueEditPart;
import hurome.diagram.edit.parts.SimpleMovement2EditPart;
import hurome.diagram.edit.parts.SimpleMovementComment2EditPart;
import hurome.diagram.edit.parts.SimpleMovementCommentEditPart;
import hurome.diagram.edit.parts.SimpleMovementEditPart;
import hurome.diagram.edit.parts.VarAssigment2EditPart;
import hurome.diagram.edit.parts.VarAssigmentComment2EditPart;
import hurome.diagram.edit.parts.VarAssigmentCommentEditPart;
import hurome.diagram.edit.parts.VarAssigmentEditPart;
import hurome.diagram.edit.parts.VarDeclaration2EditPart;
import hurome.diagram.edit.parts.VarDeclarationEditPart;
import hurome.diagram.edit.parts.VarDeclarationName2EditPart;
import hurome.diagram.edit.parts.VarDeclarationNameEditPart;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class HuromeVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "HuRoME.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (CodeBlockEditPart.MODEL_ID.equals(view.getType())) {
				return CodeBlockEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return hurome.diagram.part.HuromeVisualIDRegistry.getVisualID(view
				.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				HuromeDiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: "
								+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (HuromePackage.eINSTANCE.getCodeBlock().isSuperTypeOf(
				domainElement.eClass())
				&& isDiagram((CodeBlock) domainElement)) {
			return CodeBlockEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = hurome.diagram.part.HuromeVisualIDRegistry
				.getModelID(containerView);
		if (!CodeBlockEditPart.MODEL_ID.equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if (CodeBlockEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = hurome.diagram.part.HuromeVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = CodeBlockEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case CodeBlockEditPart.VISUAL_ID:
			if (HuromePackage.eINSTANCE.getConditional().isSuperTypeOf(
					domainElement.eClass())) {
				return ConditionalEditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getInitialPseudoMovement()
					.isSuperTypeOf(domainElement.eClass())) {
				return InitialPseudoMovementEditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getDelay().isSuperTypeOf(
					domainElement.eClass())) {
				return DelayEditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getFinalPseudoMovement().isSuperTypeOf(
					domainElement.eClass())) {
				return FinalPseudoMovementEditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getVarAssigment().isSuperTypeOf(
					domainElement.eClass())) {
				return VarAssigmentEditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getSetSpeed().isSuperTypeOf(
					domainElement.eClass())) {
				return SetSpeedEditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getSimpleMovement().isSuperTypeOf(
					domainElement.eClass())) {
				return SimpleMovementEditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getVarDeclaration().isSuperTypeOf(
					domainElement.eClass())) {
				return VarDeclarationEditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getLoop().isSuperTypeOf(
					domainElement.eClass())) {
				return LoopEditPart.VISUAL_ID;
			}
			break;
		case ConditionalIfCompartmentEditPart.VISUAL_ID:
			if (HuromePackage.eINSTANCE.getCodeBlock().isSuperTypeOf(
					domainElement.eClass())) {
				return CodeBlock2EditPart.VISUAL_ID;
			}
			break;
		case ConditionalElseCompartmentEditPart.VISUAL_ID:
			if (HuromePackage.eINSTANCE.getCodeBlock().isSuperTypeOf(
					domainElement.eClass())) {
				return CodeBlock3EditPart.VISUAL_ID;
			}
			break;
		case CodeBlockCbCompartmentEditPart.VISUAL_ID:
			if (HuromePackage.eINSTANCE.getDelay().isSuperTypeOf(
					domainElement.eClass())) {
				return Delay2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getInitialPseudoMovement()
					.isSuperTypeOf(domainElement.eClass())) {
				return InitialPseudoMovement2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getConditional().isSuperTypeOf(
					domainElement.eClass())) {
				return Conditional2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getFinalPseudoMovement().isSuperTypeOf(
					domainElement.eClass())) {
				return FinalPseudoMovement2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getLoop().isSuperTypeOf(
					domainElement.eClass())) {
				return Loop2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getSetSpeed().isSuperTypeOf(
					domainElement.eClass())) {
				return SetSpeed2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getSimpleMovement().isSuperTypeOf(
					domainElement.eClass())) {
				return SimpleMovement2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getVarAssigment().isSuperTypeOf(
					domainElement.eClass())) {
				return VarAssigment2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getVarDeclaration().isSuperTypeOf(
					domainElement.eClass())) {
				return VarDeclaration2EditPart.VISUAL_ID;
			}
			break;
		case ConditionalIfCompartment2EditPart.VISUAL_ID:
			if (HuromePackage.eINSTANCE.getCodeBlock().isSuperTypeOf(
					domainElement.eClass())) {
				return CodeBlock2EditPart.VISUAL_ID;
			}
			break;
		case ConditionalElseCompartment2EditPart.VISUAL_ID:
			if (HuromePackage.eINSTANCE.getCodeBlock().isSuperTypeOf(
					domainElement.eClass())) {
				return CodeBlock3EditPart.VISUAL_ID;
			}
			break;
		case CodeBlockCbCompartment2EditPart.VISUAL_ID:
			if (HuromePackage.eINSTANCE.getDelay().isSuperTypeOf(
					domainElement.eClass())) {
				return Delay2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getInitialPseudoMovement()
					.isSuperTypeOf(domainElement.eClass())) {
				return InitialPseudoMovement2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getConditional().isSuperTypeOf(
					domainElement.eClass())) {
				return Conditional2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getFinalPseudoMovement().isSuperTypeOf(
					domainElement.eClass())) {
				return FinalPseudoMovement2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getLoop().isSuperTypeOf(
					domainElement.eClass())) {
				return Loop2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getSetSpeed().isSuperTypeOf(
					domainElement.eClass())) {
				return SetSpeed2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getSimpleMovement().isSuperTypeOf(
					domainElement.eClass())) {
				return SimpleMovement2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getVarAssigment().isSuperTypeOf(
					domainElement.eClass())) {
				return VarAssigment2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getVarDeclaration().isSuperTypeOf(
					domainElement.eClass())) {
				return VarDeclaration2EditPart.VISUAL_ID;
			}
			break;
		case LoopLoopFigureCompartmentEditPart.VISUAL_ID:
			if (HuromePackage.eINSTANCE.getDelay().isSuperTypeOf(
					domainElement.eClass())) {
				return Delay2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getInitialPseudoMovement()
					.isSuperTypeOf(domainElement.eClass())) {
				return InitialPseudoMovement2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getConditional().isSuperTypeOf(
					domainElement.eClass())) {
				return Conditional2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getFinalPseudoMovement().isSuperTypeOf(
					domainElement.eClass())) {
				return FinalPseudoMovement2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getLoop().isSuperTypeOf(
					domainElement.eClass())) {
				return Loop2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getSetSpeed().isSuperTypeOf(
					domainElement.eClass())) {
				return SetSpeed2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getSimpleMovement().isSuperTypeOf(
					domainElement.eClass())) {
				return SimpleMovement2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getVarAssigment().isSuperTypeOf(
					domainElement.eClass())) {
				return VarAssigment2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getVarDeclaration().isSuperTypeOf(
					domainElement.eClass())) {
				return VarDeclaration2EditPart.VISUAL_ID;
			}
			break;
		case LoopLoopFigureCompartment2EditPart.VISUAL_ID:
			if (HuromePackage.eINSTANCE.getDelay().isSuperTypeOf(
					domainElement.eClass())) {
				return Delay2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getInitialPseudoMovement()
					.isSuperTypeOf(domainElement.eClass())) {
				return InitialPseudoMovement2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getConditional().isSuperTypeOf(
					domainElement.eClass())) {
				return Conditional2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getFinalPseudoMovement().isSuperTypeOf(
					domainElement.eClass())) {
				return FinalPseudoMovement2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getLoop().isSuperTypeOf(
					domainElement.eClass())) {
				return Loop2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getSetSpeed().isSuperTypeOf(
					domainElement.eClass())) {
				return SetSpeed2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getSimpleMovement().isSuperTypeOf(
					domainElement.eClass())) {
				return SimpleMovement2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getVarAssigment().isSuperTypeOf(
					domainElement.eClass())) {
				return VarAssigment2EditPart.VISUAL_ID;
			}
			if (HuromePackage.eINSTANCE.getVarDeclaration().isSuperTypeOf(
					domainElement.eClass())) {
				return VarDeclaration2EditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = hurome.diagram.part.HuromeVisualIDRegistry
				.getModelID(containerView);
		if (!CodeBlockEditPart.MODEL_ID.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (CodeBlockEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = hurome.diagram.part.HuromeVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = CodeBlockEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case CodeBlockEditPart.VISUAL_ID:
			if (ConditionalEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (InitialPseudoMovementEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (DelayEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (FinalPseudoMovementEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (VarAssigmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SetSpeedEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SimpleMovementEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (VarDeclarationEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (LoopEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ConditionalEditPart.VISUAL_ID:
			if (ConditionalCommentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ConditionalIfCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ConditionalElseCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case DelayEditPart.VISUAL_ID:
			if (DelayValueEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case VarAssigmentEditPart.VISUAL_ID:
			if (VarAssigmentCommentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SetSpeedEditPart.VISUAL_ID:
			if (SetSpeedValueEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SimpleMovementEditPart.VISUAL_ID:
			if (SimpleMovementCommentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case VarDeclarationEditPart.VISUAL_ID:
			if (VarDeclarationNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case LoopEditPart.VISUAL_ID:
			if (LoopCommentLoopsEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (LoopLoopFigureCompartment2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case CodeBlock2EditPart.VISUAL_ID:
			if (CodeBlockCbCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Delay2EditPart.VISUAL_ID:
			if (DelayValue2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Conditional2EditPart.VISUAL_ID:
			if (ConditionalComment2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ConditionalIfCompartment2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ConditionalElseCompartment2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case CodeBlock3EditPart.VISUAL_ID:
			if (CodeBlockCbCompartment2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Loop2EditPart.VISUAL_ID:
			if (LoopCommentLoops2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (LoopLoopFigureCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SetSpeed2EditPart.VISUAL_ID:
			if (SetSpeedValue2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SimpleMovement2EditPart.VISUAL_ID:
			if (SimpleMovementComment2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case VarAssigment2EditPart.VISUAL_ID:
			if (VarAssigmentComment2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case VarDeclaration2EditPart.VISUAL_ID:
			if (VarDeclarationName2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ConditionalIfCompartmentEditPart.VISUAL_ID:
			if (CodeBlock2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ConditionalElseCompartmentEditPart.VISUAL_ID:
			if (CodeBlock3EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case CodeBlockCbCompartmentEditPart.VISUAL_ID:
			if (Delay2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (InitialPseudoMovement2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Conditional2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (FinalPseudoMovement2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Loop2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SetSpeed2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SimpleMovement2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (VarAssigment2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (VarDeclaration2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ConditionalIfCompartment2EditPart.VISUAL_ID:
			if (CodeBlock2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ConditionalElseCompartment2EditPart.VISUAL_ID:
			if (CodeBlock3EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case CodeBlockCbCompartment2EditPart.VISUAL_ID:
			if (Delay2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (InitialPseudoMovement2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Conditional2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (FinalPseudoMovement2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Loop2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SetSpeed2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SimpleMovement2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (VarAssigment2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (VarDeclaration2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case LoopLoopFigureCompartmentEditPart.VISUAL_ID:
			if (Delay2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (InitialPseudoMovement2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Conditional2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (FinalPseudoMovement2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Loop2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SetSpeed2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SimpleMovement2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (VarAssigment2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (VarDeclaration2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case LoopLoopFigureCompartment2EditPart.VISUAL_ID:
			if (Delay2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (InitialPseudoMovement2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Conditional2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (FinalPseudoMovement2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Loop2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SetSpeed2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SimpleMovement2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (VarAssigment2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (VarDeclaration2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (HuromePackage.eINSTANCE.getSequenceLink().isSuperTypeOf(
				domainElement.eClass())) {
			return SequenceLinkEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(CodeBlock element) {
		return true;
	}

}
