/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package hurome;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Code Block</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link hurome.CodeBlock#getLinks <em>Links</em>}</li>
 *   <li>{@link hurome.CodeBlock#getNodes <em>Nodes</em>}</li>
 *   <li>{@link hurome.CodeBlock#getIf_owner <em>If owner</em>}</li>
 *   <li>{@link hurome.CodeBlock#getElse_owner <em>Else owner</em>}</li>
 * </ul>
 * </p>
 *
 * @see hurome.HuromePackage#getCodeBlock()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='CodeBlocksRequireOneFinalPseudoMovement NotIncomingAndOutgoingRequired CodeBlocksRequireAtLeastOneNodeDifferentFromInitialAndFinalPseudoMovements CodeBlocksRequireOneInitialPseudoMovement InternalCodeBlocksRequireOneIncomingSequenceLink InternalCodeBlocksRequireOneOutgoingSequenceLink'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL CodeBlocksRequireOneFinalPseudoMovement='\n\t\t\tself->select(n|n.oclIsTypeOf(Loop))->isEmpty() implies self.nodes->select(n|n.oclIsTypeOf(FinalPseudoMovement))->size()=1' NotIncomingAndOutgoingRequired='\n\t\t\tself.if_owner->notEmpty() implies self.incoming->isEmpty() and self.outgoing->isEmpty()' CodeBlocksRequireAtLeastOneNodeDifferentFromInitialAndFinalPseudoMovements='\n\t\t\tself.nodes->select(n|not(n.oclIsTypeOf(FinalPseudoMovement) and not(n.oclIsTypeOf(InitialPseudoMovement))))->size()>=1' CodeBlocksRequireOneInitialPseudoMovement='\n\t\t\tself.nodes->select(r|r.oclIsTypeOf(InitialPseudoMovement))->size()=1' InternalCodeBlocksRequireOneIncomingSequenceLink='\n\t\t\tself.owner->notEmpty() implies self.incoming->size()=1' InternalCodeBlocksRequireOneOutgoingSequenceLink='\n\t\t\tself.owner->notEmpty() implies self.outgoing->size()=1'"
 * @generated
 */
public interface CodeBlock extends Node {
	/**
	 * Returns the value of the '<em><b>Links</b></em>' containment reference list.
	 * The list contents are of type {@link hurome.SequenceLink}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Links</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Links</em>' containment reference list.
	 * @see hurome.HuromePackage#getCodeBlock_Links()
	 * @model containment="true" lower="2"
	 * @generated
	 */
	EList<SequenceLink> getLinks();

	/**
	 * Returns the value of the '<em><b>Nodes</b></em>' containment reference list.
	 * The list contents are of type {@link hurome.Node}.
	 * It is bidirectional and its opposite is '{@link hurome.Node#getOwner <em>Owner</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Nodes</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Nodes</em>' containment reference list.
	 * @see hurome.HuromePackage#getCodeBlock_Nodes()
	 * @see hurome.Node#getOwner
	 * @model opposite="owner" containment="true" lower="2"
	 * @generated
	 */
	EList<Node> getNodes();

	/**
	 * Returns the value of the '<em><b>If owner</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link hurome.Conditional#getIf_true <em>If true</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>If owner</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>If owner</em>' container reference.
	 * @see #setIf_owner(Conditional)
	 * @see hurome.HuromePackage#getCodeBlock_If_owner()
	 * @see hurome.Conditional#getIf_true
	 * @model opposite="if_true" transient="false"
	 * @generated
	 */
	Conditional getIf_owner();

	/**
	 * Sets the value of the '{@link hurome.CodeBlock#getIf_owner <em>If owner</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>If owner</em>' container reference.
	 * @see #getIf_owner()
	 * @generated
	 */
	void setIf_owner(Conditional value);

	/**
	 * Returns the value of the '<em><b>Else owner</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link hurome.Conditional#getElse_false <em>Else false</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Else owner</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Else owner</em>' container reference.
	 * @see #setElse_owner(Conditional)
	 * @see hurome.HuromePackage#getCodeBlock_Else_owner()
	 * @see hurome.Conditional#getElse_false
	 * @model opposite="else_false" transient="false"
	 * @generated
	 */
	Conditional getElse_owner();

	/**
	 * Sets the value of the '{@link hurome.CodeBlock#getElse_owner <em>Else owner</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Else owner</em>' container reference.
	 * @see #getElse_owner()
	 * @generated
	 */
	void setElse_owner(Conditional value);

} // CodeBlock
