/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package hurome;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see hurome.HuromeFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore invocationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL' settingDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL' validationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL'"
 * @generated
 */
public interface HuromePackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "hurome";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http//:hurome";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "hurome";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	HuromePackage eINSTANCE = hurome.impl.HuromePackageImpl.init();

	/**
	 * The meta object id for the '{@link hurome.impl.NodeImpl <em>Node</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.NodeImpl
	 * @see hurome.impl.HuromePackageImpl#getNode()
	 * @generated
	 */
	int NODE = 0;

	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__COMMENT = 0;

	/**
	 * The feature id for the '<em><b>Owner</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__OWNER = 1;

	/**
	 * The feature id for the '<em><b>Incoming</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__INCOMING = 2;

	/**
	 * The feature id for the '<em><b>Outgoing</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__OUTGOING = 3;

	/**
	 * The number of structural features of the '<em>Node</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_FEATURE_COUNT = 4;

	/**
	 * The meta object id for the '{@link hurome.impl.SequenceLinkImpl <em>Sequence Link</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.SequenceLinkImpl
	 * @see hurome.impl.HuromePackageImpl#getSequenceLink()
	 * @generated
	 */
	int SEQUENCE_LINK = 1;

	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_LINK__COMMENT = 0;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_LINK__SOURCE = 1;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_LINK__TARGET = 2;

	/**
	 * The number of structural features of the '<em>Sequence Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_LINK_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link hurome.impl.ConditionalImpl <em>Conditional</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.ConditionalImpl
	 * @see hurome.impl.HuromePackageImpl#getConditional()
	 * @generated
	 */
	int CONDITIONAL = 2;

	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL__COMMENT = NODE__COMMENT;

	/**
	 * The feature id for the '<em><b>Owner</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL__OWNER = NODE__OWNER;

	/**
	 * The feature id for the '<em><b>Incoming</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL__INCOMING = NODE__INCOMING;

	/**
	 * The feature id for the '<em><b>Outgoing</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL__OUTGOING = NODE__OUTGOING;

	/**
	 * The feature id for the '<em><b>If true</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL__IF_TRUE = NODE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Else false</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL__ELSE_FALSE = NODE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Term</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL__TERM = NODE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Conditional</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL_FEATURE_COUNT = NODE_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link hurome.impl.VarAssigmentImpl <em>Var Assigment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.VarAssigmentImpl
	 * @see hurome.impl.HuromePackageImpl#getVarAssigment()
	 * @generated
	 */
	int VAR_ASSIGMENT = 3;

	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR_ASSIGMENT__COMMENT = NODE__COMMENT;

	/**
	 * The feature id for the '<em><b>Owner</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR_ASSIGMENT__OWNER = NODE__OWNER;

	/**
	 * The feature id for the '<em><b>Incoming</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR_ASSIGMENT__INCOMING = NODE__INCOMING;

	/**
	 * The feature id for the '<em><b>Outgoing</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR_ASSIGMENT__OUTGOING = NODE__OUTGOING;

	/**
	 * The feature id for the '<em><b>Variable</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR_ASSIGMENT__VARIABLE = NODE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Term</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR_ASSIGMENT__TERM = NODE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Var Assigment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR_ASSIGMENT_FEATURE_COUNT = NODE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link hurome.impl.VarDeclarationImpl <em>Var Declaration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.VarDeclarationImpl
	 * @see hurome.impl.HuromePackageImpl#getVarDeclaration()
	 * @generated
	 */
	int VAR_DECLARATION = 4;

	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR_DECLARATION__COMMENT = NODE__COMMENT;

	/**
	 * The feature id for the '<em><b>Owner</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR_DECLARATION__OWNER = NODE__OWNER;

	/**
	 * The feature id for the '<em><b>Incoming</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR_DECLARATION__INCOMING = NODE__INCOMING;

	/**
	 * The feature id for the '<em><b>Outgoing</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR_DECLARATION__OUTGOING = NODE__OUTGOING;

	/**
	 * The feature id for the '<em><b>Default Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR_DECLARATION__DEFAULT_VALUE = NODE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR_DECLARATION__TYPE = NODE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR_DECLARATION__NAME = NODE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Var Declaration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR_DECLARATION_FEATURE_COUNT = NODE_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link hurome.impl.SetSpeedImpl <em>Set Speed</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.SetSpeedImpl
	 * @see hurome.impl.HuromePackageImpl#getSetSpeed()
	 * @generated
	 */
	int SET_SPEED = 5;

	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_SPEED__COMMENT = NODE__COMMENT;

	/**
	 * The feature id for the '<em><b>Owner</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_SPEED__OWNER = NODE__OWNER;

	/**
	 * The feature id for the '<em><b>Incoming</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_SPEED__INCOMING = NODE__INCOMING;

	/**
	 * The feature id for the '<em><b>Outgoing</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_SPEED__OUTGOING = NODE__OUTGOING;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_SPEED__VALUE = NODE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Set Speed</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_SPEED_FEATURE_COUNT = NODE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link hurome.impl.DelayImpl <em>Delay</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.DelayImpl
	 * @see hurome.impl.HuromePackageImpl#getDelay()
	 * @generated
	 */
	int DELAY = 6;

	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELAY__COMMENT = NODE__COMMENT;

	/**
	 * The feature id for the '<em><b>Owner</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELAY__OWNER = NODE__OWNER;

	/**
	 * The feature id for the '<em><b>Incoming</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELAY__INCOMING = NODE__INCOMING;

	/**
	 * The feature id for the '<em><b>Outgoing</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELAY__OUTGOING = NODE__OUTGOING;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELAY__VALUE = NODE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Delay</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELAY_FEATURE_COUNT = NODE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link hurome.impl.FinalPseudoMovementImpl <em>Final Pseudo Movement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.FinalPseudoMovementImpl
	 * @see hurome.impl.HuromePackageImpl#getFinalPseudoMovement()
	 * @generated
	 */
	int FINAL_PSEUDO_MOVEMENT = 7;

	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FINAL_PSEUDO_MOVEMENT__COMMENT = NODE__COMMENT;

	/**
	 * The feature id for the '<em><b>Owner</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FINAL_PSEUDO_MOVEMENT__OWNER = NODE__OWNER;

	/**
	 * The feature id for the '<em><b>Incoming</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FINAL_PSEUDO_MOVEMENT__INCOMING = NODE__INCOMING;

	/**
	 * The feature id for the '<em><b>Outgoing</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FINAL_PSEUDO_MOVEMENT__OUTGOING = NODE__OUTGOING;

	/**
	 * The number of structural features of the '<em>Final Pseudo Movement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FINAL_PSEUDO_MOVEMENT_FEATURE_COUNT = NODE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link hurome.impl.SimpleMovementImpl <em>Simple Movement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.SimpleMovementImpl
	 * @see hurome.impl.HuromePackageImpl#getSimpleMovement()
	 * @generated
	 */
	int SIMPLE_MOVEMENT = 8;

	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__COMMENT = NODE__COMMENT;

	/**
	 * The feature id for the '<em><b>Owner</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__OWNER = NODE__OWNER;

	/**
	 * The feature id for the '<em><b>Incoming</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__INCOMING = NODE__INCOMING;

	/**
	 * The feature id for the '<em><b>Outgoing</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__OUTGOING = NODE__OUTGOING;

	/**
	 * The feature id for the '<em><b>Servo Angle 00</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_00 = NODE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Servo Angle 01</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_01 = NODE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Servo Angle 02</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_02 = NODE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Servo Angle 03</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_03 = NODE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Servo Angle 04</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_04 = NODE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Servo Angle 05</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_05 = NODE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Servo Angle 06</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_06 = NODE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Servo Angle 07</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_07 = NODE_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Servo Angle 08</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_08 = NODE_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Servo Angle 09</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_09 = NODE_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Servo Angle 10</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_10 = NODE_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>Servo Angle 11</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_11 = NODE_FEATURE_COUNT + 11;

	/**
	 * The feature id for the '<em><b>Servo Angle 12</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_12 = NODE_FEATURE_COUNT + 12;

	/**
	 * The feature id for the '<em><b>Servo Angle 13</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_13 = NODE_FEATURE_COUNT + 13;

	/**
	 * The feature id for the '<em><b>Servo Angle 14</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_14 = NODE_FEATURE_COUNT + 14;

	/**
	 * The feature id for the '<em><b>Servo Angle 15</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_15 = NODE_FEATURE_COUNT + 15;

	/**
	 * The feature id for the '<em><b>Servo Angle 16</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_16 = NODE_FEATURE_COUNT + 16;

	/**
	 * The feature id for the '<em><b>Servo Angle 17</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_17 = NODE_FEATURE_COUNT + 17;

	/**
	 * The feature id for the '<em><b>Servo Angle 18</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_18 = NODE_FEATURE_COUNT + 18;

	/**
	 * The feature id for the '<em><b>Servo Angle 19</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_19 = NODE_FEATURE_COUNT + 19;

	/**
	 * The feature id for the '<em><b>Servo Angle 20</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_20 = NODE_FEATURE_COUNT + 20;

	/**
	 * The feature id for the '<em><b>Servo Angle 21</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_21 = NODE_FEATURE_COUNT + 21;

	/**
	 * The feature id for the '<em><b>Servo Angle 22</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_22 = NODE_FEATURE_COUNT + 22;

	/**
	 * The feature id for the '<em><b>Servo Angle 23</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__SERVO_ANGLE_23 = NODE_FEATURE_COUNT + 23;

	/**
	 * The feature id for the '<em><b>Ptpall</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT__PTPALL = NODE_FEATURE_COUNT + 24;

	/**
	 * The number of structural features of the '<em>Simple Movement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_MOVEMENT_FEATURE_COUNT = NODE_FEATURE_COUNT + 25;

	/**
	 * The meta object id for the '{@link hurome.impl.InitialPseudoMovementImpl <em>Initial Pseudo Movement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.InitialPseudoMovementImpl
	 * @see hurome.impl.HuromePackageImpl#getInitialPseudoMovement()
	 * @generated
	 */
	int INITIAL_PSEUDO_MOVEMENT = 9;

	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INITIAL_PSEUDO_MOVEMENT__COMMENT = NODE__COMMENT;

	/**
	 * The feature id for the '<em><b>Owner</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INITIAL_PSEUDO_MOVEMENT__OWNER = NODE__OWNER;

	/**
	 * The feature id for the '<em><b>Incoming</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INITIAL_PSEUDO_MOVEMENT__INCOMING = NODE__INCOMING;

	/**
	 * The feature id for the '<em><b>Outgoing</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INITIAL_PSEUDO_MOVEMENT__OUTGOING = NODE__OUTGOING;

	/**
	 * The number of structural features of the '<em>Initial Pseudo Movement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INITIAL_PSEUDO_MOVEMENT_FEATURE_COUNT = NODE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link hurome.impl.CodeBlockImpl <em>Code Block</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.CodeBlockImpl
	 * @see hurome.impl.HuromePackageImpl#getCodeBlock()
	 * @generated
	 */
	int CODE_BLOCK = 10;

	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODE_BLOCK__COMMENT = NODE__COMMENT;

	/**
	 * The feature id for the '<em><b>Owner</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODE_BLOCK__OWNER = NODE__OWNER;

	/**
	 * The feature id for the '<em><b>Incoming</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODE_BLOCK__INCOMING = NODE__INCOMING;

	/**
	 * The feature id for the '<em><b>Outgoing</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODE_BLOCK__OUTGOING = NODE__OUTGOING;

	/**
	 * The feature id for the '<em><b>Links</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODE_BLOCK__LINKS = NODE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Nodes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODE_BLOCK__NODES = NODE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>If owner</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODE_BLOCK__IF_OWNER = NODE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Else owner</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODE_BLOCK__ELSE_OWNER = NODE_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Code Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODE_BLOCK_FEATURE_COUNT = NODE_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link hurome.impl.TermImpl <em>Term</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.TermImpl
	 * @see hurome.impl.HuromePackageImpl#getTerm()
	 * @generated
	 */
	int TERM = 11;

	/**
	 * The number of structural features of the '<em>Term</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERM_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link hurome.impl.VariableImpl <em>Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.VariableImpl
	 * @see hurome.impl.HuromePackageImpl#getVariable()
	 * @generated
	 */
	int VARIABLE = 12;

	/**
	 * The feature id for the '<em><b>Variable</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE__VARIABLE = TERM_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_FEATURE_COUNT = TERM_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link hurome.impl.ConstantImpl <em>Constant</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.ConstantImpl
	 * @see hurome.impl.HuromePackageImpl#getConstant()
	 * @generated
	 */
	int CONSTANT = 13;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT__VALUE = TERM_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Constant</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_FEATURE_COUNT = TERM_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link hurome.impl.UnaryOpImpl <em>Unary Op</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.UnaryOpImpl
	 * @see hurome.impl.HuromePackageImpl#getUnaryOp()
	 * @generated
	 */
	int UNARY_OP = 14;

	/**
	 * The feature id for the '<em><b>Operand</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_OP__OPERAND = TERM_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Unary Op</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_OP_FEATURE_COUNT = TERM_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link hurome.impl.BinaryOpImpl <em>Binary Op</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.BinaryOpImpl
	 * @see hurome.impl.HuromePackageImpl#getBinaryOp()
	 * @generated
	 */
	int BINARY_OP = 15;

	/**
	 * The feature id for the '<em><b>Operand1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_OP__OPERAND1 = TERM_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Operand2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_OP__OPERAND2 = TERM_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Binary Op</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_OP_FEATURE_COUNT = TERM_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link hurome.impl.NotImpl <em>Not</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.NotImpl
	 * @see hurome.impl.HuromePackageImpl#getNot()
	 * @generated
	 */
	int NOT = 16;

	/**
	 * The feature id for the '<em><b>Operand</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NOT__OPERAND = UNARY_OP__OPERAND;

	/**
	 * The number of structural features of the '<em>Not</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NOT_FEATURE_COUNT = UNARY_OP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link hurome.impl.RelationalOpImpl <em>Relational Op</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.RelationalOpImpl
	 * @see hurome.impl.HuromePackageImpl#getRelationalOp()
	 * @generated
	 */
	int RELATIONAL_OP = 17;

	/**
	 * The feature id for the '<em><b>Operand1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONAL_OP__OPERAND1 = BINARY_OP__OPERAND1;

	/**
	 * The feature id for the '<em><b>Operand2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONAL_OP__OPERAND2 = BINARY_OP__OPERAND2;

	/**
	 * The number of structural features of the '<em>Relational Op</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONAL_OP_FEATURE_COUNT = BINARY_OP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link hurome.impl.AddImpl <em>Add</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.AddImpl
	 * @see hurome.impl.HuromePackageImpl#getAdd()
	 * @generated
	 */
	int ADD = 18;

	/**
	 * The feature id for the '<em><b>Operand1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADD__OPERAND1 = BINARY_OP__OPERAND1;

	/**
	 * The feature id for the '<em><b>Operand2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADD__OPERAND2 = BINARY_OP__OPERAND2;

	/**
	 * The number of structural features of the '<em>Add</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADD_FEATURE_COUNT = BINARY_OP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link hurome.impl.OrImpl <em>Or</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.OrImpl
	 * @see hurome.impl.HuromePackageImpl#getOr()
	 * @generated
	 */
	int OR = 19;

	/**
	 * The feature id for the '<em><b>Operand1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR__OPERAND1 = BINARY_OP__OPERAND1;

	/**
	 * The feature id for the '<em><b>Operand2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR__OPERAND2 = BINARY_OP__OPERAND2;

	/**
	 * The number of structural features of the '<em>Or</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR_FEATURE_COUNT = BINARY_OP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link hurome.impl.AndImpl <em>And</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.AndImpl
	 * @see hurome.impl.HuromePackageImpl#getAnd()
	 * @generated
	 */
	int AND = 20;

	/**
	 * The feature id for the '<em><b>Operand1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND__OPERAND1 = BINARY_OP__OPERAND1;

	/**
	 * The feature id for the '<em><b>Operand2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND__OPERAND2 = BINARY_OP__OPERAND2;

	/**
	 * The number of structural features of the '<em>And</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND_FEATURE_COUNT = BINARY_OP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link hurome.impl.DivImpl <em>Div</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.DivImpl
	 * @see hurome.impl.HuromePackageImpl#getDiv()
	 * @generated
	 */
	int DIV = 21;

	/**
	 * The feature id for the '<em><b>Operand1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIV__OPERAND1 = BINARY_OP__OPERAND1;

	/**
	 * The feature id for the '<em><b>Operand2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIV__OPERAND2 = BINARY_OP__OPERAND2;

	/**
	 * The number of structural features of the '<em>Div</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIV_FEATURE_COUNT = BINARY_OP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link hurome.impl.SubImpl <em>Sub</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.SubImpl
	 * @see hurome.impl.HuromePackageImpl#getSub()
	 * @generated
	 */
	int SUB = 22;

	/**
	 * The feature id for the '<em><b>Operand1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB__OPERAND1 = BINARY_OP__OPERAND1;

	/**
	 * The feature id for the '<em><b>Operand2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB__OPERAND2 = BINARY_OP__OPERAND2;

	/**
	 * The number of structural features of the '<em>Sub</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FEATURE_COUNT = BINARY_OP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link hurome.impl.MultImpl <em>Mult</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.MultImpl
	 * @see hurome.impl.HuromePackageImpl#getMult()
	 * @generated
	 */
	int MULT = 23;

	/**
	 * The feature id for the '<em><b>Operand1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULT__OPERAND1 = BINARY_OP__OPERAND1;

	/**
	 * The feature id for the '<em><b>Operand2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULT__OPERAND2 = BINARY_OP__OPERAND2;

	/**
	 * The number of structural features of the '<em>Mult</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULT_FEATURE_COUNT = BINARY_OP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link hurome.impl.XorImpl <em>Xor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.XorImpl
	 * @see hurome.impl.HuromePackageImpl#getXor()
	 * @generated
	 */
	int XOR = 24;

	/**
	 * The feature id for the '<em><b>Operand1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XOR__OPERAND1 = BINARY_OP__OPERAND1;

	/**
	 * The feature id for the '<em><b>Operand2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XOR__OPERAND2 = BINARY_OP__OPERAND2;

	/**
	 * The number of structural features of the '<em>Xor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XOR_FEATURE_COUNT = BINARY_OP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link hurome.impl.ModImpl <em>Mod</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.ModImpl
	 * @see hurome.impl.HuromePackageImpl#getMod()
	 * @generated
	 */
	int MOD = 25;

	/**
	 * The feature id for the '<em><b>Operand1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOD__OPERAND1 = BINARY_OP__OPERAND1;

	/**
	 * The feature id for the '<em><b>Operand2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOD__OPERAND2 = BINARY_OP__OPERAND2;

	/**
	 * The number of structural features of the '<em>Mod</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOD_FEATURE_COUNT = BINARY_OP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link hurome.impl.LessImpl <em>Less</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.LessImpl
	 * @see hurome.impl.HuromePackageImpl#getLess()
	 * @generated
	 */
	int LESS = 26;

	/**
	 * The feature id for the '<em><b>Operand1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS__OPERAND1 = RELATIONAL_OP__OPERAND1;

	/**
	 * The feature id for the '<em><b>Operand2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS__OPERAND2 = RELATIONAL_OP__OPERAND2;

	/**
	 * The number of structural features of the '<em>Less</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS_FEATURE_COUNT = RELATIONAL_OP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link hurome.impl.EqualImpl <em>Equal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.EqualImpl
	 * @see hurome.impl.HuromePackageImpl#getEqual()
	 * @generated
	 */
	int EQUAL = 27;

	/**
	 * The feature id for the '<em><b>Operand1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUAL__OPERAND1 = RELATIONAL_OP__OPERAND1;

	/**
	 * The feature id for the '<em><b>Operand2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUAL__OPERAND2 = RELATIONAL_OP__OPERAND2;

	/**
	 * The number of structural features of the '<em>Equal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUAL_FEATURE_COUNT = RELATIONAL_OP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link hurome.impl.LessOrEqualImpl <em>Less Or Equal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.LessOrEqualImpl
	 * @see hurome.impl.HuromePackageImpl#getLessOrEqual()
	 * @generated
	 */
	int LESS_OR_EQUAL = 28;

	/**
	 * The feature id for the '<em><b>Operand1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS_OR_EQUAL__OPERAND1 = RELATIONAL_OP__OPERAND1;

	/**
	 * The feature id for the '<em><b>Operand2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS_OR_EQUAL__OPERAND2 = RELATIONAL_OP__OPERAND2;

	/**
	 * The number of structural features of the '<em>Less Or Equal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS_OR_EQUAL_FEATURE_COUNT = RELATIONAL_OP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link hurome.impl.GreaterImpl <em>Greater</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.GreaterImpl
	 * @see hurome.impl.HuromePackageImpl#getGreater()
	 * @generated
	 */
	int GREATER = 29;

	/**
	 * The feature id for the '<em><b>Operand1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GREATER__OPERAND1 = RELATIONAL_OP__OPERAND1;

	/**
	 * The feature id for the '<em><b>Operand2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GREATER__OPERAND2 = RELATIONAL_OP__OPERAND2;

	/**
	 * The number of structural features of the '<em>Greater</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GREATER_FEATURE_COUNT = RELATIONAL_OP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link hurome.impl.GreaterOrEqualImpl <em>Greater Or Equal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.GreaterOrEqualImpl
	 * @see hurome.impl.HuromePackageImpl#getGreaterOrEqual()
	 * @generated
	 */
	int GREATER_OR_EQUAL = 30;

	/**
	 * The feature id for the '<em><b>Operand1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GREATER_OR_EQUAL__OPERAND1 = RELATIONAL_OP__OPERAND1;

	/**
	 * The feature id for the '<em><b>Operand2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GREATER_OR_EQUAL__OPERAND2 = RELATIONAL_OP__OPERAND2;

	/**
	 * The number of structural features of the '<em>Greater Or Equal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GREATER_OR_EQUAL_FEATURE_COUNT = RELATIONAL_OP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link hurome.impl.ConstDeclarationImpl <em>Const Declaration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.ConstDeclarationImpl
	 * @see hurome.impl.HuromePackageImpl#getConstDeclaration()
	 * @generated
	 */
	int CONST_DECLARATION = 31;

	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONST_DECLARATION__COMMENT = NODE__COMMENT;

	/**
	 * The feature id for the '<em><b>Owner</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONST_DECLARATION__OWNER = NODE__OWNER;

	/**
	 * The feature id for the '<em><b>Incoming</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONST_DECLARATION__INCOMING = NODE__INCOMING;

	/**
	 * The feature id for the '<em><b>Outgoing</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONST_DECLARATION__OUTGOING = NODE__OUTGOING;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONST_DECLARATION__NAME = NODE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONST_DECLARATION__VALUE = NODE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Const Declaration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONST_DECLARATION_FEATURE_COUNT = NODE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link hurome.impl.LoopImpl <em>Loop</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.impl.LoopImpl
	 * @see hurome.impl.HuromePackageImpl#getLoop()
	 * @generated
	 */
	int LOOP = 32;

	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP__COMMENT = CODE_BLOCK__COMMENT;

	/**
	 * The feature id for the '<em><b>Owner</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP__OWNER = CODE_BLOCK__OWNER;

	/**
	 * The feature id for the '<em><b>Incoming</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP__INCOMING = CODE_BLOCK__INCOMING;

	/**
	 * The feature id for the '<em><b>Outgoing</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP__OUTGOING = CODE_BLOCK__OUTGOING;

	/**
	 * The feature id for the '<em><b>Links</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP__LINKS = CODE_BLOCK__LINKS;

	/**
	 * The feature id for the '<em><b>Nodes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP__NODES = CODE_BLOCK__NODES;

	/**
	 * The feature id for the '<em><b>If owner</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP__IF_OWNER = CODE_BLOCK__IF_OWNER;

	/**
	 * The feature id for the '<em><b>Else owner</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP__ELSE_OWNER = CODE_BLOCK__ELSE_OWNER;

	/**
	 * The feature id for the '<em><b>Loops</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP__LOOPS = CODE_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Loop</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_FEATURE_COUNT = CODE_BLOCK_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link hurome.VariableType <em>Variable Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see hurome.VariableType
	 * @see hurome.impl.HuromePackageImpl#getVariableType()
	 * @generated
	 */
	int VARIABLE_TYPE = 33;


	/**
	 * Returns the meta object for class '{@link hurome.Node <em>Node</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Node</em>'.
	 * @see hurome.Node
	 * @generated
	 */
	EClass getNode();

	/**
	 * Returns the meta object for the attribute '{@link hurome.Node#getComment <em>Comment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Comment</em>'.
	 * @see hurome.Node#getComment()
	 * @see #getNode()
	 * @generated
	 */
	EAttribute getNode_Comment();

	/**
	 * Returns the meta object for the container reference '{@link hurome.Node#getOwner <em>Owner</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Owner</em>'.
	 * @see hurome.Node#getOwner()
	 * @see #getNode()
	 * @generated
	 */
	EReference getNode_Owner();

	/**
	 * Returns the meta object for the reference list '{@link hurome.Node#getIncoming <em>Incoming</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Incoming</em>'.
	 * @see hurome.Node#getIncoming()
	 * @see #getNode()
	 * @generated
	 */
	EReference getNode_Incoming();

	/**
	 * Returns the meta object for the reference list '{@link hurome.Node#getOutgoing <em>Outgoing</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Outgoing</em>'.
	 * @see hurome.Node#getOutgoing()
	 * @see #getNode()
	 * @generated
	 */
	EReference getNode_Outgoing();

	/**
	 * Returns the meta object for class '{@link hurome.SequenceLink <em>Sequence Link</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sequence Link</em>'.
	 * @see hurome.SequenceLink
	 * @generated
	 */
	EClass getSequenceLink();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SequenceLink#getComment <em>Comment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Comment</em>'.
	 * @see hurome.SequenceLink#getComment()
	 * @see #getSequenceLink()
	 * @generated
	 */
	EAttribute getSequenceLink_Comment();

	/**
	 * Returns the meta object for the reference '{@link hurome.SequenceLink#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Source</em>'.
	 * @see hurome.SequenceLink#getSource()
	 * @see #getSequenceLink()
	 * @generated
	 */
	EReference getSequenceLink_Source();

	/**
	 * Returns the meta object for the reference '{@link hurome.SequenceLink#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Target</em>'.
	 * @see hurome.SequenceLink#getTarget()
	 * @see #getSequenceLink()
	 * @generated
	 */
	EReference getSequenceLink_Target();

	/**
	 * Returns the meta object for class '{@link hurome.Conditional <em>Conditional</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Conditional</em>'.
	 * @see hurome.Conditional
	 * @generated
	 */
	EClass getConditional();

	/**
	 * Returns the meta object for the containment reference '{@link hurome.Conditional#getIf_true <em>If true</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>If true</em>'.
	 * @see hurome.Conditional#getIf_true()
	 * @see #getConditional()
	 * @generated
	 */
	EReference getConditional_If_true();

	/**
	 * Returns the meta object for the containment reference '{@link hurome.Conditional#getElse_false <em>Else false</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Else false</em>'.
	 * @see hurome.Conditional#getElse_false()
	 * @see #getConditional()
	 * @generated
	 */
	EReference getConditional_Else_false();

	/**
	 * Returns the meta object for the containment reference '{@link hurome.Conditional#getTerm <em>Term</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Term</em>'.
	 * @see hurome.Conditional#getTerm()
	 * @see #getConditional()
	 * @generated
	 */
	EReference getConditional_Term();

	/**
	 * Returns the meta object for class '{@link hurome.VarAssigment <em>Var Assigment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Var Assigment</em>'.
	 * @see hurome.VarAssigment
	 * @generated
	 */
	EClass getVarAssigment();

	/**
	 * Returns the meta object for the reference '{@link hurome.VarAssigment#getVariable <em>Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Variable</em>'.
	 * @see hurome.VarAssigment#getVariable()
	 * @see #getVarAssigment()
	 * @generated
	 */
	EReference getVarAssigment_Variable();

	/**
	 * Returns the meta object for the containment reference '{@link hurome.VarAssigment#getTerm <em>Term</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Term</em>'.
	 * @see hurome.VarAssigment#getTerm()
	 * @see #getVarAssigment()
	 * @generated
	 */
	EReference getVarAssigment_Term();

	/**
	 * Returns the meta object for class '{@link hurome.VarDeclaration <em>Var Declaration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Var Declaration</em>'.
	 * @see hurome.VarDeclaration
	 * @generated
	 */
	EClass getVarDeclaration();

	/**
	 * Returns the meta object for the attribute '{@link hurome.VarDeclaration#getDefaultValue <em>Default Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Default Value</em>'.
	 * @see hurome.VarDeclaration#getDefaultValue()
	 * @see #getVarDeclaration()
	 * @generated
	 */
	EAttribute getVarDeclaration_DefaultValue();

	/**
	 * Returns the meta object for the attribute '{@link hurome.VarDeclaration#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see hurome.VarDeclaration#getType()
	 * @see #getVarDeclaration()
	 * @generated
	 */
	EAttribute getVarDeclaration_Type();

	/**
	 * Returns the meta object for the attribute '{@link hurome.VarDeclaration#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see hurome.VarDeclaration#getName()
	 * @see #getVarDeclaration()
	 * @generated
	 */
	EAttribute getVarDeclaration_Name();

	/**
	 * Returns the meta object for class '{@link hurome.SetSpeed <em>Set Speed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Set Speed</em>'.
	 * @see hurome.SetSpeed
	 * @generated
	 */
	EClass getSetSpeed();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SetSpeed#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see hurome.SetSpeed#getValue()
	 * @see #getSetSpeed()
	 * @generated
	 */
	EAttribute getSetSpeed_Value();

	/**
	 * Returns the meta object for class '{@link hurome.Delay <em>Delay</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Delay</em>'.
	 * @see hurome.Delay
	 * @generated
	 */
	EClass getDelay();

	/**
	 * Returns the meta object for the attribute '{@link hurome.Delay#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see hurome.Delay#getValue()
	 * @see #getDelay()
	 * @generated
	 */
	EAttribute getDelay_Value();

	/**
	 * Returns the meta object for class '{@link hurome.FinalPseudoMovement <em>Final Pseudo Movement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Final Pseudo Movement</em>'.
	 * @see hurome.FinalPseudoMovement
	 * @generated
	 */
	EClass getFinalPseudoMovement();

	/**
	 * Returns the meta object for class '{@link hurome.SimpleMovement <em>Simple Movement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Simple Movement</em>'.
	 * @see hurome.SimpleMovement
	 * @generated
	 */
	EClass getSimpleMovement();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_00 <em>Servo Angle 00</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 00</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_00()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_00();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_01 <em>Servo Angle 01</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 01</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_01()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_01();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_02 <em>Servo Angle 02</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 02</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_02()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_02();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_03 <em>Servo Angle 03</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 03</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_03()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_03();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_04 <em>Servo Angle 04</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 04</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_04()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_04();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_05 <em>Servo Angle 05</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 05</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_05()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_05();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_06 <em>Servo Angle 06</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 06</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_06()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_06();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_07 <em>Servo Angle 07</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 07</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_07()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_07();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_08 <em>Servo Angle 08</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 08</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_08()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_08();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_09 <em>Servo Angle 09</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 09</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_09()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_09();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_10 <em>Servo Angle 10</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 10</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_10()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_10();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_11 <em>Servo Angle 11</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 11</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_11()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_11();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_12 <em>Servo Angle 12</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 12</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_12()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_12();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_13 <em>Servo Angle 13</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 13</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_13()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_13();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_14 <em>Servo Angle 14</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 14</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_14()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_14();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_15 <em>Servo Angle 15</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 15</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_15()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_15();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_16 <em>Servo Angle 16</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 16</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_16()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_16();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_17 <em>Servo Angle 17</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 17</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_17()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_17();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_18 <em>Servo Angle 18</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 18</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_18()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_18();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_19 <em>Servo Angle 19</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 19</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_19()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_19();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_20 <em>Servo Angle 20</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 20</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_20()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_20();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_21 <em>Servo Angle 21</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 21</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_21()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_21();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_22 <em>Servo Angle 22</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 22</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_22()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_22();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#getServoAngle_23 <em>Servo Angle 23</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Servo Angle 23</em>'.
	 * @see hurome.SimpleMovement#getServoAngle_23()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_ServoAngle_23();

	/**
	 * Returns the meta object for the attribute '{@link hurome.SimpleMovement#isPtpall <em>Ptpall</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ptpall</em>'.
	 * @see hurome.SimpleMovement#isPtpall()
	 * @see #getSimpleMovement()
	 * @generated
	 */
	EAttribute getSimpleMovement_Ptpall();

	/**
	 * Returns the meta object for class '{@link hurome.InitialPseudoMovement <em>Initial Pseudo Movement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Initial Pseudo Movement</em>'.
	 * @see hurome.InitialPseudoMovement
	 * @generated
	 */
	EClass getInitialPseudoMovement();

	/**
	 * Returns the meta object for class '{@link hurome.CodeBlock <em>Code Block</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Code Block</em>'.
	 * @see hurome.CodeBlock
	 * @generated
	 */
	EClass getCodeBlock();

	/**
	 * Returns the meta object for the containment reference list '{@link hurome.CodeBlock#getLinks <em>Links</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Links</em>'.
	 * @see hurome.CodeBlock#getLinks()
	 * @see #getCodeBlock()
	 * @generated
	 */
	EReference getCodeBlock_Links();

	/**
	 * Returns the meta object for the containment reference list '{@link hurome.CodeBlock#getNodes <em>Nodes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Nodes</em>'.
	 * @see hurome.CodeBlock#getNodes()
	 * @see #getCodeBlock()
	 * @generated
	 */
	EReference getCodeBlock_Nodes();

	/**
	 * Returns the meta object for the container reference '{@link hurome.CodeBlock#getIf_owner <em>If owner</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>If owner</em>'.
	 * @see hurome.CodeBlock#getIf_owner()
	 * @see #getCodeBlock()
	 * @generated
	 */
	EReference getCodeBlock_If_owner();

	/**
	 * Returns the meta object for the container reference '{@link hurome.CodeBlock#getElse_owner <em>Else owner</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Else owner</em>'.
	 * @see hurome.CodeBlock#getElse_owner()
	 * @see #getCodeBlock()
	 * @generated
	 */
	EReference getCodeBlock_Else_owner();

	/**
	 * Returns the meta object for class '{@link hurome.Term <em>Term</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Term</em>'.
	 * @see hurome.Term
	 * @generated
	 */
	EClass getTerm();

	/**
	 * Returns the meta object for class '{@link hurome.Variable <em>Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Variable</em>'.
	 * @see hurome.Variable
	 * @generated
	 */
	EClass getVariable();

	/**
	 * Returns the meta object for the reference '{@link hurome.Variable#getVariable <em>Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Variable</em>'.
	 * @see hurome.Variable#getVariable()
	 * @see #getVariable()
	 * @generated
	 */
	EReference getVariable_Variable();

	/**
	 * Returns the meta object for class '{@link hurome.Constant <em>Constant</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constant</em>'.
	 * @see hurome.Constant
	 * @generated
	 */
	EClass getConstant();

	/**
	 * Returns the meta object for the attribute '{@link hurome.Constant#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see hurome.Constant#getValue()
	 * @see #getConstant()
	 * @generated
	 */
	EAttribute getConstant_Value();

	/**
	 * Returns the meta object for class '{@link hurome.UnaryOp <em>Unary Op</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unary Op</em>'.
	 * @see hurome.UnaryOp
	 * @generated
	 */
	EClass getUnaryOp();

	/**
	 * Returns the meta object for the containment reference '{@link hurome.UnaryOp#getOperand <em>Operand</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Operand</em>'.
	 * @see hurome.UnaryOp#getOperand()
	 * @see #getUnaryOp()
	 * @generated
	 */
	EReference getUnaryOp_Operand();

	/**
	 * Returns the meta object for class '{@link hurome.BinaryOp <em>Binary Op</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Binary Op</em>'.
	 * @see hurome.BinaryOp
	 * @generated
	 */
	EClass getBinaryOp();

	/**
	 * Returns the meta object for the containment reference '{@link hurome.BinaryOp#getOperand1 <em>Operand1</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Operand1</em>'.
	 * @see hurome.BinaryOp#getOperand1()
	 * @see #getBinaryOp()
	 * @generated
	 */
	EReference getBinaryOp_Operand1();

	/**
	 * Returns the meta object for the containment reference '{@link hurome.BinaryOp#getOperand2 <em>Operand2</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Operand2</em>'.
	 * @see hurome.BinaryOp#getOperand2()
	 * @see #getBinaryOp()
	 * @generated
	 */
	EReference getBinaryOp_Operand2();

	/**
	 * Returns the meta object for class '{@link hurome.Not <em>Not</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Not</em>'.
	 * @see hurome.Not
	 * @generated
	 */
	EClass getNot();

	/**
	 * Returns the meta object for class '{@link hurome.RelationalOp <em>Relational Op</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Relational Op</em>'.
	 * @see hurome.RelationalOp
	 * @generated
	 */
	EClass getRelationalOp();

	/**
	 * Returns the meta object for class '{@link hurome.Add <em>Add</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Add</em>'.
	 * @see hurome.Add
	 * @generated
	 */
	EClass getAdd();

	/**
	 * Returns the meta object for class '{@link hurome.Or <em>Or</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Or</em>'.
	 * @see hurome.Or
	 * @generated
	 */
	EClass getOr();

	/**
	 * Returns the meta object for class '{@link hurome.And <em>And</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>And</em>'.
	 * @see hurome.And
	 * @generated
	 */
	EClass getAnd();

	/**
	 * Returns the meta object for class '{@link hurome.Div <em>Div</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Div</em>'.
	 * @see hurome.Div
	 * @generated
	 */
	EClass getDiv();

	/**
	 * Returns the meta object for class '{@link hurome.Sub <em>Sub</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sub</em>'.
	 * @see hurome.Sub
	 * @generated
	 */
	EClass getSub();

	/**
	 * Returns the meta object for class '{@link hurome.Mult <em>Mult</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mult</em>'.
	 * @see hurome.Mult
	 * @generated
	 */
	EClass getMult();

	/**
	 * Returns the meta object for class '{@link hurome.Xor <em>Xor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Xor</em>'.
	 * @see hurome.Xor
	 * @generated
	 */
	EClass getXor();

	/**
	 * Returns the meta object for class '{@link hurome.Mod <em>Mod</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mod</em>'.
	 * @see hurome.Mod
	 * @generated
	 */
	EClass getMod();

	/**
	 * Returns the meta object for class '{@link hurome.Less <em>Less</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Less</em>'.
	 * @see hurome.Less
	 * @generated
	 */
	EClass getLess();

	/**
	 * Returns the meta object for class '{@link hurome.Equal <em>Equal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Equal</em>'.
	 * @see hurome.Equal
	 * @generated
	 */
	EClass getEqual();

	/**
	 * Returns the meta object for class '{@link hurome.LessOrEqual <em>Less Or Equal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Less Or Equal</em>'.
	 * @see hurome.LessOrEqual
	 * @generated
	 */
	EClass getLessOrEqual();

	/**
	 * Returns the meta object for class '{@link hurome.Greater <em>Greater</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Greater</em>'.
	 * @see hurome.Greater
	 * @generated
	 */
	EClass getGreater();

	/**
	 * Returns the meta object for class '{@link hurome.GreaterOrEqual <em>Greater Or Equal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Greater Or Equal</em>'.
	 * @see hurome.GreaterOrEqual
	 * @generated
	 */
	EClass getGreaterOrEqual();

	/**
	 * Returns the meta object for class '{@link hurome.ConstDeclaration <em>Const Declaration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Const Declaration</em>'.
	 * @see hurome.ConstDeclaration
	 * @generated
	 */
	EClass getConstDeclaration();

	/**
	 * Returns the meta object for the attribute '{@link hurome.ConstDeclaration#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see hurome.ConstDeclaration#getName()
	 * @see #getConstDeclaration()
	 * @generated
	 */
	EAttribute getConstDeclaration_Name();

	/**
	 * Returns the meta object for the attribute '{@link hurome.ConstDeclaration#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see hurome.ConstDeclaration#getValue()
	 * @see #getConstDeclaration()
	 * @generated
	 */
	EAttribute getConstDeclaration_Value();

	/**
	 * Returns the meta object for class '{@link hurome.Loop <em>Loop</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Loop</em>'.
	 * @see hurome.Loop
	 * @generated
	 */
	EClass getLoop();

	/**
	 * Returns the meta object for the attribute '{@link hurome.Loop#getLoops <em>Loops</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Loops</em>'.
	 * @see hurome.Loop#getLoops()
	 * @see #getLoop()
	 * @generated
	 */
	EAttribute getLoop_Loops();

	/**
	 * Returns the meta object for enum '{@link hurome.VariableType <em>Variable Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Variable Type</em>'.
	 * @see hurome.VariableType
	 * @generated
	 */
	EEnum getVariableType();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	HuromeFactory getHuromeFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link hurome.impl.NodeImpl <em>Node</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.NodeImpl
		 * @see hurome.impl.HuromePackageImpl#getNode()
		 * @generated
		 */
		EClass NODE = eINSTANCE.getNode();

		/**
		 * The meta object literal for the '<em><b>Comment</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NODE__COMMENT = eINSTANCE.getNode_Comment();

		/**
		 * The meta object literal for the '<em><b>Owner</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NODE__OWNER = eINSTANCE.getNode_Owner();

		/**
		 * The meta object literal for the '<em><b>Incoming</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NODE__INCOMING = eINSTANCE.getNode_Incoming();

		/**
		 * The meta object literal for the '<em><b>Outgoing</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NODE__OUTGOING = eINSTANCE.getNode_Outgoing();

		/**
		 * The meta object literal for the '{@link hurome.impl.SequenceLinkImpl <em>Sequence Link</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.SequenceLinkImpl
		 * @see hurome.impl.HuromePackageImpl#getSequenceLink()
		 * @generated
		 */
		EClass SEQUENCE_LINK = eINSTANCE.getSequenceLink();

		/**
		 * The meta object literal for the '<em><b>Comment</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SEQUENCE_LINK__COMMENT = eINSTANCE.getSequenceLink_Comment();

		/**
		 * The meta object literal for the '<em><b>Source</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SEQUENCE_LINK__SOURCE = eINSTANCE.getSequenceLink_Source();

		/**
		 * The meta object literal for the '<em><b>Target</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SEQUENCE_LINK__TARGET = eINSTANCE.getSequenceLink_Target();

		/**
		 * The meta object literal for the '{@link hurome.impl.ConditionalImpl <em>Conditional</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.ConditionalImpl
		 * @see hurome.impl.HuromePackageImpl#getConditional()
		 * @generated
		 */
		EClass CONDITIONAL = eINSTANCE.getConditional();

		/**
		 * The meta object literal for the '<em><b>If true</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONDITIONAL__IF_TRUE = eINSTANCE.getConditional_If_true();

		/**
		 * The meta object literal for the '<em><b>Else false</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONDITIONAL__ELSE_FALSE = eINSTANCE.getConditional_Else_false();

		/**
		 * The meta object literal for the '<em><b>Term</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONDITIONAL__TERM = eINSTANCE.getConditional_Term();

		/**
		 * The meta object literal for the '{@link hurome.impl.VarAssigmentImpl <em>Var Assigment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.VarAssigmentImpl
		 * @see hurome.impl.HuromePackageImpl#getVarAssigment()
		 * @generated
		 */
		EClass VAR_ASSIGMENT = eINSTANCE.getVarAssigment();

		/**
		 * The meta object literal for the '<em><b>Variable</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference VAR_ASSIGMENT__VARIABLE = eINSTANCE.getVarAssigment_Variable();

		/**
		 * The meta object literal for the '<em><b>Term</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference VAR_ASSIGMENT__TERM = eINSTANCE.getVarAssigment_Term();

		/**
		 * The meta object literal for the '{@link hurome.impl.VarDeclarationImpl <em>Var Declaration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.VarDeclarationImpl
		 * @see hurome.impl.HuromePackageImpl#getVarDeclaration()
		 * @generated
		 */
		EClass VAR_DECLARATION = eINSTANCE.getVarDeclaration();

		/**
		 * The meta object literal for the '<em><b>Default Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute VAR_DECLARATION__DEFAULT_VALUE = eINSTANCE.getVarDeclaration_DefaultValue();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute VAR_DECLARATION__TYPE = eINSTANCE.getVarDeclaration_Type();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute VAR_DECLARATION__NAME = eINSTANCE.getVarDeclaration_Name();

		/**
		 * The meta object literal for the '{@link hurome.impl.SetSpeedImpl <em>Set Speed</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.SetSpeedImpl
		 * @see hurome.impl.HuromePackageImpl#getSetSpeed()
		 * @generated
		 */
		EClass SET_SPEED = eINSTANCE.getSetSpeed();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SET_SPEED__VALUE = eINSTANCE.getSetSpeed_Value();

		/**
		 * The meta object literal for the '{@link hurome.impl.DelayImpl <em>Delay</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.DelayImpl
		 * @see hurome.impl.HuromePackageImpl#getDelay()
		 * @generated
		 */
		EClass DELAY = eINSTANCE.getDelay();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DELAY__VALUE = eINSTANCE.getDelay_Value();

		/**
		 * The meta object literal for the '{@link hurome.impl.FinalPseudoMovementImpl <em>Final Pseudo Movement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.FinalPseudoMovementImpl
		 * @see hurome.impl.HuromePackageImpl#getFinalPseudoMovement()
		 * @generated
		 */
		EClass FINAL_PSEUDO_MOVEMENT = eINSTANCE.getFinalPseudoMovement();

		/**
		 * The meta object literal for the '{@link hurome.impl.SimpleMovementImpl <em>Simple Movement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.SimpleMovementImpl
		 * @see hurome.impl.HuromePackageImpl#getSimpleMovement()
		 * @generated
		 */
		EClass SIMPLE_MOVEMENT = eINSTANCE.getSimpleMovement();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 00</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_00 = eINSTANCE.getSimpleMovement_ServoAngle_00();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 01</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_01 = eINSTANCE.getSimpleMovement_ServoAngle_01();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 02</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_02 = eINSTANCE.getSimpleMovement_ServoAngle_02();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 03</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_03 = eINSTANCE.getSimpleMovement_ServoAngle_03();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 04</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_04 = eINSTANCE.getSimpleMovement_ServoAngle_04();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 05</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_05 = eINSTANCE.getSimpleMovement_ServoAngle_05();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 06</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_06 = eINSTANCE.getSimpleMovement_ServoAngle_06();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 07</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_07 = eINSTANCE.getSimpleMovement_ServoAngle_07();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 08</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_08 = eINSTANCE.getSimpleMovement_ServoAngle_08();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 09</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_09 = eINSTANCE.getSimpleMovement_ServoAngle_09();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 10</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_10 = eINSTANCE.getSimpleMovement_ServoAngle_10();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 11</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_11 = eINSTANCE.getSimpleMovement_ServoAngle_11();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 12</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_12 = eINSTANCE.getSimpleMovement_ServoAngle_12();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 13</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_13 = eINSTANCE.getSimpleMovement_ServoAngle_13();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 14</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_14 = eINSTANCE.getSimpleMovement_ServoAngle_14();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 15</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_15 = eINSTANCE.getSimpleMovement_ServoAngle_15();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 16</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_16 = eINSTANCE.getSimpleMovement_ServoAngle_16();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 17</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_17 = eINSTANCE.getSimpleMovement_ServoAngle_17();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 18</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_18 = eINSTANCE.getSimpleMovement_ServoAngle_18();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 19</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_19 = eINSTANCE.getSimpleMovement_ServoAngle_19();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 20</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_20 = eINSTANCE.getSimpleMovement_ServoAngle_20();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 21</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_21 = eINSTANCE.getSimpleMovement_ServoAngle_21();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 22</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_22 = eINSTANCE.getSimpleMovement_ServoAngle_22();

		/**
		 * The meta object literal for the '<em><b>Servo Angle 23</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__SERVO_ANGLE_23 = eINSTANCE.getSimpleMovement_ServoAngle_23();

		/**
		 * The meta object literal for the '<em><b>Ptpall</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_MOVEMENT__PTPALL = eINSTANCE.getSimpleMovement_Ptpall();

		/**
		 * The meta object literal for the '{@link hurome.impl.InitialPseudoMovementImpl <em>Initial Pseudo Movement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.InitialPseudoMovementImpl
		 * @see hurome.impl.HuromePackageImpl#getInitialPseudoMovement()
		 * @generated
		 */
		EClass INITIAL_PSEUDO_MOVEMENT = eINSTANCE.getInitialPseudoMovement();

		/**
		 * The meta object literal for the '{@link hurome.impl.CodeBlockImpl <em>Code Block</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.CodeBlockImpl
		 * @see hurome.impl.HuromePackageImpl#getCodeBlock()
		 * @generated
		 */
		EClass CODE_BLOCK = eINSTANCE.getCodeBlock();

		/**
		 * The meta object literal for the '<em><b>Links</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CODE_BLOCK__LINKS = eINSTANCE.getCodeBlock_Links();

		/**
		 * The meta object literal for the '<em><b>Nodes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CODE_BLOCK__NODES = eINSTANCE.getCodeBlock_Nodes();

		/**
		 * The meta object literal for the '<em><b>If owner</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CODE_BLOCK__IF_OWNER = eINSTANCE.getCodeBlock_If_owner();

		/**
		 * The meta object literal for the '<em><b>Else owner</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CODE_BLOCK__ELSE_OWNER = eINSTANCE.getCodeBlock_Else_owner();

		/**
		 * The meta object literal for the '{@link hurome.impl.TermImpl <em>Term</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.TermImpl
		 * @see hurome.impl.HuromePackageImpl#getTerm()
		 * @generated
		 */
		EClass TERM = eINSTANCE.getTerm();

		/**
		 * The meta object literal for the '{@link hurome.impl.VariableImpl <em>Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.VariableImpl
		 * @see hurome.impl.HuromePackageImpl#getVariable()
		 * @generated
		 */
		EClass VARIABLE = eINSTANCE.getVariable();

		/**
		 * The meta object literal for the '<em><b>Variable</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference VARIABLE__VARIABLE = eINSTANCE.getVariable_Variable();

		/**
		 * The meta object literal for the '{@link hurome.impl.ConstantImpl <em>Constant</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.ConstantImpl
		 * @see hurome.impl.HuromePackageImpl#getConstant()
		 * @generated
		 */
		EClass CONSTANT = eINSTANCE.getConstant();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CONSTANT__VALUE = eINSTANCE.getConstant_Value();

		/**
		 * The meta object literal for the '{@link hurome.impl.UnaryOpImpl <em>Unary Op</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.UnaryOpImpl
		 * @see hurome.impl.HuromePackageImpl#getUnaryOp()
		 * @generated
		 */
		EClass UNARY_OP = eINSTANCE.getUnaryOp();

		/**
		 * The meta object literal for the '<em><b>Operand</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference UNARY_OP__OPERAND = eINSTANCE.getUnaryOp_Operand();

		/**
		 * The meta object literal for the '{@link hurome.impl.BinaryOpImpl <em>Binary Op</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.BinaryOpImpl
		 * @see hurome.impl.HuromePackageImpl#getBinaryOp()
		 * @generated
		 */
		EClass BINARY_OP = eINSTANCE.getBinaryOp();

		/**
		 * The meta object literal for the '<em><b>Operand1</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BINARY_OP__OPERAND1 = eINSTANCE.getBinaryOp_Operand1();

		/**
		 * The meta object literal for the '<em><b>Operand2</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BINARY_OP__OPERAND2 = eINSTANCE.getBinaryOp_Operand2();

		/**
		 * The meta object literal for the '{@link hurome.impl.NotImpl <em>Not</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.NotImpl
		 * @see hurome.impl.HuromePackageImpl#getNot()
		 * @generated
		 */
		EClass NOT = eINSTANCE.getNot();

		/**
		 * The meta object literal for the '{@link hurome.impl.RelationalOpImpl <em>Relational Op</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.RelationalOpImpl
		 * @see hurome.impl.HuromePackageImpl#getRelationalOp()
		 * @generated
		 */
		EClass RELATIONAL_OP = eINSTANCE.getRelationalOp();

		/**
		 * The meta object literal for the '{@link hurome.impl.AddImpl <em>Add</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.AddImpl
		 * @see hurome.impl.HuromePackageImpl#getAdd()
		 * @generated
		 */
		EClass ADD = eINSTANCE.getAdd();

		/**
		 * The meta object literal for the '{@link hurome.impl.OrImpl <em>Or</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.OrImpl
		 * @see hurome.impl.HuromePackageImpl#getOr()
		 * @generated
		 */
		EClass OR = eINSTANCE.getOr();

		/**
		 * The meta object literal for the '{@link hurome.impl.AndImpl <em>And</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.AndImpl
		 * @see hurome.impl.HuromePackageImpl#getAnd()
		 * @generated
		 */
		EClass AND = eINSTANCE.getAnd();

		/**
		 * The meta object literal for the '{@link hurome.impl.DivImpl <em>Div</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.DivImpl
		 * @see hurome.impl.HuromePackageImpl#getDiv()
		 * @generated
		 */
		EClass DIV = eINSTANCE.getDiv();

		/**
		 * The meta object literal for the '{@link hurome.impl.SubImpl <em>Sub</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.SubImpl
		 * @see hurome.impl.HuromePackageImpl#getSub()
		 * @generated
		 */
		EClass SUB = eINSTANCE.getSub();

		/**
		 * The meta object literal for the '{@link hurome.impl.MultImpl <em>Mult</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.MultImpl
		 * @see hurome.impl.HuromePackageImpl#getMult()
		 * @generated
		 */
		EClass MULT = eINSTANCE.getMult();

		/**
		 * The meta object literal for the '{@link hurome.impl.XorImpl <em>Xor</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.XorImpl
		 * @see hurome.impl.HuromePackageImpl#getXor()
		 * @generated
		 */
		EClass XOR = eINSTANCE.getXor();

		/**
		 * The meta object literal for the '{@link hurome.impl.ModImpl <em>Mod</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.ModImpl
		 * @see hurome.impl.HuromePackageImpl#getMod()
		 * @generated
		 */
		EClass MOD = eINSTANCE.getMod();

		/**
		 * The meta object literal for the '{@link hurome.impl.LessImpl <em>Less</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.LessImpl
		 * @see hurome.impl.HuromePackageImpl#getLess()
		 * @generated
		 */
		EClass LESS = eINSTANCE.getLess();

		/**
		 * The meta object literal for the '{@link hurome.impl.EqualImpl <em>Equal</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.EqualImpl
		 * @see hurome.impl.HuromePackageImpl#getEqual()
		 * @generated
		 */
		EClass EQUAL = eINSTANCE.getEqual();

		/**
		 * The meta object literal for the '{@link hurome.impl.LessOrEqualImpl <em>Less Or Equal</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.LessOrEqualImpl
		 * @see hurome.impl.HuromePackageImpl#getLessOrEqual()
		 * @generated
		 */
		EClass LESS_OR_EQUAL = eINSTANCE.getLessOrEqual();

		/**
		 * The meta object literal for the '{@link hurome.impl.GreaterImpl <em>Greater</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.GreaterImpl
		 * @see hurome.impl.HuromePackageImpl#getGreater()
		 * @generated
		 */
		EClass GREATER = eINSTANCE.getGreater();

		/**
		 * The meta object literal for the '{@link hurome.impl.GreaterOrEqualImpl <em>Greater Or Equal</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.GreaterOrEqualImpl
		 * @see hurome.impl.HuromePackageImpl#getGreaterOrEqual()
		 * @generated
		 */
		EClass GREATER_OR_EQUAL = eINSTANCE.getGreaterOrEqual();

		/**
		 * The meta object literal for the '{@link hurome.impl.ConstDeclarationImpl <em>Const Declaration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.ConstDeclarationImpl
		 * @see hurome.impl.HuromePackageImpl#getConstDeclaration()
		 * @generated
		 */
		EClass CONST_DECLARATION = eINSTANCE.getConstDeclaration();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CONST_DECLARATION__NAME = eINSTANCE.getConstDeclaration_Name();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CONST_DECLARATION__VALUE = eINSTANCE.getConstDeclaration_Value();

		/**
		 * The meta object literal for the '{@link hurome.impl.LoopImpl <em>Loop</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.impl.LoopImpl
		 * @see hurome.impl.HuromePackageImpl#getLoop()
		 * @generated
		 */
		EClass LOOP = eINSTANCE.getLoop();

		/**
		 * The meta object literal for the '<em><b>Loops</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LOOP__LOOPS = eINSTANCE.getLoop_Loops();

		/**
		 * The meta object literal for the '{@link hurome.VariableType <em>Variable Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see hurome.VariableType
		 * @see hurome.impl.HuromePackageImpl#getVariableType()
		 * @generated
		 */
		EEnum VARIABLE_TYPE = eINSTANCE.getVariableType();

	}

} //HuromePackage
