/**
 * <copyright>
 * </copyright>
 *
 */
package org.xtext.robobasic;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.xtext.robobasic.RobobasicPackage
 * @generated
 */
public interface RobobasicFactory extends EFactory
{
  /**
   * The singleton instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  RobobasicFactory eINSTANCE = org.xtext.robobasic.impl.RobobasicFactoryImpl.init();

  /**
   * Returns a new object of class '<em>Program</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Program</em>'.
   * @generated
   */
  Program createProgram();

  /**
   * Returns a new object of class '<em>Sentences</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Sentences</em>'.
   * @generated
   */
  Sentences createSentences();

  /**
   * Returns a new object of class '<em>Declaration</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Declaration</em>'.
   * @generated
   */
  Declaration createDeclaration();

  /**
   * Returns a new object of class '<em>Constant</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Constant</em>'.
   * @generated
   */
  Constant createConstant();

  /**
   * Returns a new object of class '<em>Move24</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Move24</em>'.
   * @generated
   */
  Move24 createMove24();

  /**
   * Returns a new object of class '<em>Speed</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Speed</em>'.
   * @generated
   */
  Speed createSpeed();

  /**
   * Returns a new object of class '<em>Delay</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Delay</em>'.
   * @generated
   */
  Delay createDelay();

  /**
   * Returns a new object of class '<em>Ptpall</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Ptpall</em>'.
   * @generated
   */
  Ptpall createPtpall();

  /**
   * Returns a new object of class '<em>Assignment</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Assignment</em>'.
   * @generated
   */
  Assignment createAssignment();

  /**
   * Returns a new object of class '<em>Assign Expression</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Assign Expression</em>'.
   * @generated
   */
  AssignExpression createAssignExpression();

  /**
   * Returns a new object of class '<em>Const Term</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Const Term</em>'.
   * @generated
   */
  ConstTerm createConstTerm();

  /**
   * Returns a new object of class '<em>Var Term</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Var Term</em>'.
   * @generated
   */
  VarTerm createVarTerm();

  /**
   * Returns a new object of class '<em>Conditional</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Conditional</em>'.
   * @generated
   */
  Conditional createConditional();

  /**
   * Returns a new object of class '<em>Else Conditional</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Else Conditional</em>'.
   * @generated
   */
  ElseConditional createElseConditional();

  /**
   * Returns a new object of class '<em>Conditional Expression</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Conditional Expression</em>'.
   * @generated
   */
  ConditionalExpression createConditionalExpression();

  /**
   * Returns a new object of class '<em>Primary Conditional Expression</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Primary Conditional Expression</em>'.
   * @generated
   */
  PrimaryConditionalExpression createPrimaryConditionalExpression();

  /**
   * Returns a new object of class '<em>For</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>For</em>'.
   * @generated
   */
  For createFor();

  /**
   * Returns a new object of class '<em>Add Term</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Add Term</em>'.
   * @generated
   */
  AddTerm createAddTerm();

  /**
   * Returns a new object of class '<em>Sub Term</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Sub Term</em>'.
   * @generated
   */
  SubTerm createSubTerm();

  /**
   * Returns a new object of class '<em>Mult Term</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Mult Term</em>'.
   * @generated
   */
  MultTerm createMultTerm();

  /**
   * Returns a new object of class '<em>Div Term</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Div Term</em>'.
   * @generated
   */
  DivTerm createDivTerm();

  /**
   * Returns a new object of class '<em>Mod Term</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Mod Term</em>'.
   * @generated
   */
  ModTerm createModTerm();

  /**
   * Returns a new object of class '<em>And Term</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>And Term</em>'.
   * @generated
   */
  AndTerm createAndTerm();

  /**
   * Returns a new object of class '<em>Or Term</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Or Term</em>'.
   * @generated
   */
  OrTerm createOrTerm();

  /**
   * Returns a new object of class '<em>Xor Term</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Xor Term</em>'.
   * @generated
   */
  XorTerm createXorTerm();

  /**
   * Returns a new object of class '<em>Equal Term</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Equal Term</em>'.
   * @generated
   */
  EqualTerm createEqualTerm();

  /**
   * Returns a new object of class '<em>Less Term</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Less Term</em>'.
   * @generated
   */
  LessTerm createLessTerm();

  /**
   * Returns a new object of class '<em>Greater Term</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Greater Term</em>'.
   * @generated
   */
  GreaterTerm createGreaterTerm();

  /**
   * Returns a new object of class '<em>Equal Less Term</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Equal Less Term</em>'.
   * @generated
   */
  EqualLessTerm createEqualLessTerm();

  /**
   * Returns a new object of class '<em>Equal Greater Term</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Equal Greater Term</em>'.
   * @generated
   */
  EqualGreaterTerm createEqualGreaterTerm();

  /**
   * Returns a new object of class '<em>Not Term</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Not Term</em>'.
   * @generated
   */
  NotTerm createNotTerm();

  /**
   * Returns the package supported by this factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the package supported by this factory.
   * @generated
   */
  RobobasicPackage getRobobasicPackage();

} //RobobasicFactory
