/**
 * <copyright>
 * </copyright>
 *
 */
package org.xtext.robobasic.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.xtext.robobasic.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class RobobasicFactoryImpl extends EFactoryImpl implements RobobasicFactory
{
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static RobobasicFactory init()
  {
    try
    {
      RobobasicFactory theRobobasicFactory = (RobobasicFactory)EPackage.Registry.INSTANCE.getEFactory("http://www.xtext.org/Robobasic"); 
      if (theRobobasicFactory != null)
      {
        return theRobobasicFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new RobobasicFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RobobasicFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case RobobasicPackage.PROGRAM: return createProgram();
      case RobobasicPackage.SENTENCES: return createSentences();
      case RobobasicPackage.DECLARATION: return createDeclaration();
      case RobobasicPackage.CONSTANT: return createConstant();
      case RobobasicPackage.MOVE24: return createMove24();
      case RobobasicPackage.SPEED: return createSpeed();
      case RobobasicPackage.DELAY: return createDelay();
      case RobobasicPackage.PTPALL: return createPtpall();
      case RobobasicPackage.ASSIGNMENT: return createAssignment();
      case RobobasicPackage.ASSIGN_EXPRESSION: return createAssignExpression();
      case RobobasicPackage.CONST_TERM: return createConstTerm();
      case RobobasicPackage.VAR_TERM: return createVarTerm();
      case RobobasicPackage.CONDITIONAL: return createConditional();
      case RobobasicPackage.ELSE_CONDITIONAL: return createElseConditional();
      case RobobasicPackage.CONDITIONAL_EXPRESSION: return createConditionalExpression();
      case RobobasicPackage.PRIMARY_CONDITIONAL_EXPRESSION: return createPrimaryConditionalExpression();
      case RobobasicPackage.FOR: return createFor();
      case RobobasicPackage.ADD_TERM: return createAddTerm();
      case RobobasicPackage.SUB_TERM: return createSubTerm();
      case RobobasicPackage.MULT_TERM: return createMultTerm();
      case RobobasicPackage.DIV_TERM: return createDivTerm();
      case RobobasicPackage.MOD_TERM: return createModTerm();
      case RobobasicPackage.AND_TERM: return createAndTerm();
      case RobobasicPackage.OR_TERM: return createOrTerm();
      case RobobasicPackage.XOR_TERM: return createXorTerm();
      case RobobasicPackage.EQUAL_TERM: return createEqualTerm();
      case RobobasicPackage.LESS_TERM: return createLessTerm();
      case RobobasicPackage.GREATER_TERM: return createGreaterTerm();
      case RobobasicPackage.EQUAL_LESS_TERM: return createEqualLessTerm();
      case RobobasicPackage.EQUAL_GREATER_TERM: return createEqualGreaterTerm();
      case RobobasicPackage.NOT_TERM: return createNotTerm();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object createFromString(EDataType eDataType, String initialValue)
  {
    switch (eDataType.getClassifierID())
    {
      case RobobasicPackage.VARIABLE_TYPE:
        return createVariableTypeFromString(eDataType, initialValue);
      case RobobasicPackage.PTP_VALUE:
        return createPtpValueFromString(eDataType, initialValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String convertToString(EDataType eDataType, Object instanceValue)
  {
    switch (eDataType.getClassifierID())
    {
      case RobobasicPackage.VARIABLE_TYPE:
        return convertVariableTypeToString(eDataType, instanceValue);
      case RobobasicPackage.PTP_VALUE:
        return convertPtpValueToString(eDataType, instanceValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Program createProgram()
  {
    ProgramImpl program = new ProgramImpl();
    return program;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Sentences createSentences()
  {
    SentencesImpl sentences = new SentencesImpl();
    return sentences;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Declaration createDeclaration()
  {
    DeclarationImpl declaration = new DeclarationImpl();
    return declaration;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Constant createConstant()
  {
    ConstantImpl constant = new ConstantImpl();
    return constant;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Move24 createMove24()
  {
    Move24Impl move24 = new Move24Impl();
    return move24;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Speed createSpeed()
  {
    SpeedImpl speed = new SpeedImpl();
    return speed;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Delay createDelay()
  {
    DelayImpl delay = new DelayImpl();
    return delay;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Ptpall createPtpall()
  {
    PtpallImpl ptpall = new PtpallImpl();
    return ptpall;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Assignment createAssignment()
  {
    AssignmentImpl assignment = new AssignmentImpl();
    return assignment;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AssignExpression createAssignExpression()
  {
    AssignExpressionImpl assignExpression = new AssignExpressionImpl();
    return assignExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ConstTerm createConstTerm()
  {
    ConstTermImpl constTerm = new ConstTermImpl();
    return constTerm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VarTerm createVarTerm()
  {
    VarTermImpl varTerm = new VarTermImpl();
    return varTerm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Conditional createConditional()
  {
    ConditionalImpl conditional = new ConditionalImpl();
    return conditional;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ElseConditional createElseConditional()
  {
    ElseConditionalImpl elseConditional = new ElseConditionalImpl();
    return elseConditional;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ConditionalExpression createConditionalExpression()
  {
    ConditionalExpressionImpl conditionalExpression = new ConditionalExpressionImpl();
    return conditionalExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PrimaryConditionalExpression createPrimaryConditionalExpression()
  {
    PrimaryConditionalExpressionImpl primaryConditionalExpression = new PrimaryConditionalExpressionImpl();
    return primaryConditionalExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public For createFor()
  {
    ForImpl for_ = new ForImpl();
    return for_;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AddTerm createAddTerm()
  {
    AddTermImpl addTerm = new AddTermImpl();
    return addTerm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SubTerm createSubTerm()
  {
    SubTermImpl subTerm = new SubTermImpl();
    return subTerm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MultTerm createMultTerm()
  {
    MultTermImpl multTerm = new MultTermImpl();
    return multTerm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DivTerm createDivTerm()
  {
    DivTermImpl divTerm = new DivTermImpl();
    return divTerm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ModTerm createModTerm()
  {
    ModTermImpl modTerm = new ModTermImpl();
    return modTerm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AndTerm createAndTerm()
  {
    AndTermImpl andTerm = new AndTermImpl();
    return andTerm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public OrTerm createOrTerm()
  {
    OrTermImpl orTerm = new OrTermImpl();
    return orTerm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public XorTerm createXorTerm()
  {
    XorTermImpl xorTerm = new XorTermImpl();
    return xorTerm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EqualTerm createEqualTerm()
  {
    EqualTermImpl equalTerm = new EqualTermImpl();
    return equalTerm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public LessTerm createLessTerm()
  {
    LessTermImpl lessTerm = new LessTermImpl();
    return lessTerm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public GreaterTerm createGreaterTerm()
  {
    GreaterTermImpl greaterTerm = new GreaterTermImpl();
    return greaterTerm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EqualLessTerm createEqualLessTerm()
  {
    EqualLessTermImpl equalLessTerm = new EqualLessTermImpl();
    return equalLessTerm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EqualGreaterTerm createEqualGreaterTerm()
  {
    EqualGreaterTermImpl equalGreaterTerm = new EqualGreaterTermImpl();
    return equalGreaterTerm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotTerm createNotTerm()
  {
    NotTermImpl notTerm = new NotTermImpl();
    return notTerm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VariableType createVariableTypeFromString(EDataType eDataType, String initialValue)
  {
    VariableType result = VariableType.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertVariableTypeToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PtpValue createPtpValueFromString(EDataType eDataType, String initialValue)
  {
    PtpValue result = PtpValue.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertPtpValueToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RobobasicPackage getRobobasicPackage()
  {
    return (RobobasicPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static RobobasicPackage getPackage()
  {
    return RobobasicPackage.eINSTANCE;
  }

} //RobobasicFactoryImpl
