package serializacin;
	import java.io.IOException;
	import org.eclipse.emf.common.util.URI;
	import org.eclipse.emf.ecore.EPackage;
	import org.eclipse.emf.ecore.resource.Resource;
	import org.eclipse.emf.ecore.resource.ResourceSet;
	import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
	import org.eclipse.xtext.resource.XtextResource;
	import org.eclipse.xtext.resource.XtextResourceSet;
	import org.xtext.RobobasicStandaloneSetup;
	import org.xtext.robobasic.RobobasicPackage;
import com.google.inject.Injector;
	
	public class Bas2Xmi {
		public static void main(String[] args) {
			
			//Registro del meta-modelo
			EPackage.Registry.INSTANCE.put(RobobasicPackage.eNS_URI, RobobasicPackage.eINSTANCE);
			
			//Creacion de un recurso xtext vacio. Este recurso representa el fichero de salida
			//que sera creado una vez se complete el proceso
			Injector injector = new RobobasicStandaloneSetup().createInjectorAndDoEMFRegistration();
			ResourceSet xtextResourceSet = injector.getInstance(XtextResourceSet.class);
			XtextResource xtextInput = (XtextResource)xtextResourceSet.getResource(
			URI.createURI("file:/Users/Victor/Documents/HuRoME/Cdigo/Coreo.bas"), true);
			EcoreUtil.resolveAll(xtextInput);
						
			// Creacin de un recurso XMI de salida vaco
			Resource xmiOutput = new ResourceSetImpl().createResource(
			URI.createURI("file:/Users/Victor/Documents/HuRoME/HuRoME+/model/Coreo.xmi"));
			
			// Grabacin del recurso XMI con la informacin del modelo Xtext
			xmiOutput.getContents().add(xtextInput.getContents().get(0));
		
			//Desactivamos la validacion para evitar errores si el contenido del fichero xmi
			//tiene errores gramticales
				
			try{
				//Grabamos el fichero de salida
				xmiOutput.save(null);
				}
				catch (IOException e)
				{
					e.printStackTrace();
				}
		}
	}
	
	
	
	
	
	
