package serializacin;


	import java.io.IOException;
	import org.eclipse.emf.common.util.URI;
	import org.eclipse.emf.ecore.EPackage;
	import org.eclipse.emf.ecore.resource.Resource;
	import org.eclipse.emf.ecore.resource.ResourceSet;
	import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
	import org.eclipse.xtext.resource.XtextResource;
	import org.eclipse.xtext.resource.XtextResourceSet;
	import org.xtext.RobobasicStandaloneSetup;
	import org.xtext.robobasic.RobobasicPackage;
	import com.google.inject.Injector;

	public class Xmi2Bas {
		public static void main(String[] args) {
			//Registro del meta-modelo
			EPackage.Registry.INSTANCE.put(RobobasicPackage.eNS_URI, RobobasicPackage.eINSTANCE);
			
			
			// Recurso Xtext con la informacin del modelo textual de entrada
			Injector injector = new RobobasicStandaloneSetup().createInjectorAndDoEMFRegistration();
			ResourceSet xtextResourceSet = injector.getInstance(XtextResourceSet.class);
			XtextResource xtextResource = (XtextResource)xtextResourceSet.createResource(
					URI.createURI("file:/Users/Victor/Documents/HuRoME/" +
							"Cdigo/Coreografa.bas"));
			
			
			//Cargamos el fichero XMI
			Resource xmiResource = new ResourceSetImpl().getResource(
					URI.createURI("file:/Users/Victor/Documents/HuRoME/" +
							"M2M/defaultOut.xmi"),true);
			
			//Copiamos en el recurso de salida la informacion contenida en el fichero xmi
			xtextResource.getContents().add(xmiResource.getContents().get(0));
				
			//Desactivamos la validacion para evitar errores si el contenido del fichero xmi
			//tiene errores gramticales
			xtextResource.setValidationDisabled(true);
				
			try{
						//Grabamos el fichero de salida
						xtextResource.save(null);
				}
				catch (IOException e)
				{
					e.printStackTrace();
				}
			
		}

	}
